/*       .
*    uintN ( )  intN ( ),
*   N -     .
*/


#ifndef EXTINT_H_
#define EXTINT_H_

#if defined(HC12_IAR)                   /*  - Freescale HCS12,  - IAR */
typedef unsigned char    t_uint8;
typedef signed   char    t_int8;

typedef unsigned         t_uint16;
typedef int              t_int16;

typedef unsigned long    t_uint32;
typedef long             t_int32;

#elif (__MWERKS__ == 1)               /*  - CodeWarrior */
#include <stdtypes.h>
typedef Byte t_uint8;
typedef sByte t_int8;

typedef Word t_uint16;
typedef sWord t_int16;

typedef LWord t_uint32;
typedef sLWord t_int32;

#elif defined(AVR_IAR)                  /*  - Atmel AVR,  - IAR */
typedef unsigned char    t_uint8;
typedef signed char      t_int8;

typedef unsigned         t_uint16;
typedef int              t_int16;

typedef unsigned long    t_uint32;
typedef long             t_int32;


#elif defined(_MSC_VER)                 /*  - 86,  - Microsoft Visual C++ */
typedef unsigned char    t_uint8;
typedef signed char      t_int8;

typedef unsigned short   t_uint16;
typedef short            t_int16;

typedef unsigned         t_uint32;
typedef int              t_int32;

typedef unsigned __int64 t_uint64;
typedef __int64          t_int64;


#elif defined(_CVI_)                  /*  86,  - National Instruments CVI */
#if (_CVI_ >= 600)
typedef unsigned char    t_uint8;
typedef signed char      t_int8;

typedef unsigned short   t_uint16;
typedef short            t_int16;

typedef unsigned         t_uint32;
typedef int              t_int32;

#if (_CVI_ >= 700)
typedef unsigned __int64 t_uint64;
typedef __int64          t_int64;
#endif
#endif


#elif defined(ARM_IAR)                /*  - ARM,  - IAR */
typedef unsigned char    t_uint8;
typedef signed char      t_int8;

typedef unsigned short   t_uint16;
typedef short            t_int16;

typedef unsigned int     t_uint32;
typedef int              t_int32;

typedef unsigned long long t_uint64;
typedef long long          t_int64;


#elif defined(ARM_RVCT)                /*  - ARM,  - RealView */
typedef unsigned char    t_uint8;
typedef signed char      t_int8;

typedef unsigned short   t_uint16;
typedef short            t_int16;

typedef unsigned int     t_uint32;
typedef int              t_int32;

typedef unsigned __int64 t_uint64;
typedef __int64          t_int64;

#elif (defined(__ADSPBLACKFIN__) && (__ADSPBLACKFIN__ == 1))

typedef unsigned char t_uint8;
typedef signed char t_int8;

typedef unsigned short t_uint16;
typedef short t_int16;

typedef unsigned long t_uint32;
typedef long t_int32;

typedef unsigned long long t_uint64;
typedef long long t_int64;

#else
#error Unknown platform
#endif

#endif        /*#ifndef EXTINT_H_*/

