#ifndef LAN8700_H_
#define LAN8700_H_

/*================================================================================================*/
#define LAN8700_CTRL_REG           (0)
#define LAN8700_STATUS_REG         (1)
#define LAN8700_ID1_REG            (2)
#define LAN8700_ID2_REG            (3)
#define LAN8700_AN_ADVERTISE_REG   (4)
#define LAN8700_AN_LNKABILITY_REG  (5)
#define LAN8700_AN_EXPANSION_REG   (6)
#define LAN8700_REV_REG            (16)
#define LAN8700_MODE_REG           (17)
#define LAN8700_SPECMODE_REG       (18)
#define LAN8700_ERRCOUNT_REG       (26)
#define LAN8700_CTRLSTATUS_IND_REG (27)
#define LAN8700_INTERNAL_TEST_REG  (28)
#define LAN8700_INT_SOURCE_REG     (29)
#define LAN8700_INT_MASK_REG       (30)
#define LAN8700_SPEC_CTRLSTAT_REG  (31)

#define LAN8700_CTRL_COLLISIONTEST_MASK (0x0080U)
#define LAN8700_CTRL_DUPLEXMODE_MASK    (0x0100U)
#define LAN8700_CTRL_RESTARTAN_MASK     (0x0200U)
#define LAN8700_CTRL_ISOLATE_MASK       (0x0400U)
#define LAN8700_CTRL_PWRDWN_MASK        (0x0800U)
#define LAN8700_CTRL_ANEN_MASK          (0x1000U)
#define LAN8700_CTRL_SPDSEL_MASK        (0x2000U)
#define LAN8700_CTRL_LOOPBACK_MASK      (0x4000U)
#define LAN8700_CTRL_RST_MASK           (0x8000U)

#define LAN8700_STATUS_EXTCAPABILITY_MASK (0x0001U)
#define LAN8700_STATUS_JABBERDETECT_MASK  (0x0002U)
#define LAN8700_STATUS_LNKSTAT_MASK       (0x0004U)
#define LAN8700_STATUS_ANABILITY_MASK     (0x0008U)
#define LAN8700_STATUS_REMOTEFAULT_MASK   (0x0010U)
#define LAN8700_STATUS_ANCOMPLETE_MASK    (0x0020U)
#define LAN8700_STATUS_10BTHDUPLEX_MASK   (0x0800U)
#define LAN8700_STATUS_10BTFDUPLEX_MASK   (0x1000U)
#define LAN8700_STATUS_100BTXHDUPLEX_MASK (0x2000U)
#define LAN8700_STATUS_100BTXFDUPLEX_MASK (0x4000U)
#define LAN8700_STATUS_100BT4_MASK        (0x8000U)
/*================================================================================================*/

#endif /*#ifndef LAN8700_H_*/
