#ifndef GLOBDEFS_H_
#define GLOBDEFS_H_

#include "HARDWARE/hardware.h"
#include "ProcessCommand.h"
#include "ProcessData.h"
#include "../../../include/extint.h"

//#include "lwip/init.h" 
//#include "lwip/tcpip.h"
//#include "lwip/sockets.h"
//#include "lwip/inet.h"

/* Scheduler includes. */
#include "FreeRTOS.h"

#ifdef _VDK_
#include "VDK.h"
#endif

#ifdef _USE_LWIP_
#include <lwip/sockets.h>
#include <lwip/inet.h>
#endif


/*================================================================================================*/
#define LTR031_ENDPOINT
#define DATA_HOOK_EN (0)
#define ETH_DATAPART (2048)
#if (ETH_DATAPART % 2 != 0)
  #error ETH_DATAPART must be even
#endif
#if ((ETH_DATAPART < 4) || (16384 <= ETH_DATAPART))
  #error ETH_DATAPART must be > 4 and < 16384
#endif
/*================================================================================================*/

/*================================================================================================*/
enum e_DeviceMode {e_DeviceMode_USB, e_DeviceMode_ETH};
enum e_LED {e_LED_OFF = 0x00, e_LED_Red = 0x01, e_LED_Green = 0x02, e_LED_Orange, e_LED_RedPulse};
/*================================================================================================*/

/*================================================================================================*/
extern BYTE DataRecvFromPCRunning;
extern BYTE DataSendToPCRunning;
extern t_uint8 g_altera_info[ 510 ];
extern enum e_DeviceMode g_device_mode;
extern enum e_LED g_mode_ELED;
extern enum e_LED g_mode_ULED;
extern int g_altera_reset;
extern WORD NumTestSpeedData;
extern int TestClientSocket;
extern BYTE TestSpeedReadRunning;
extern BYTE TestSpeedWriteRunning;
/*================================================================================================*/

/*================================================================================================*/
void clear_extwdt(void);
/*================================================================================================*/

#endif /*#ifndef GLOBDEFS_H_*/
