#pragma once

#ifndef HAL_H_
#define HAL_H_

#include "ccblkfn.h"
#include "sysreg.h"

#include <sys\platform.h>
#include <sys\exception.h>
#include <math.h>   // min max

//   AD
/*
#include <services/services.h>     // system services
#include <drivers/adi_dev.h>        // Device Manager
#include <drivers/spi/adi_spi.h>	// SPI
*/

typedef unsigned char 	BYTE;
typedef unsigned short 	WORD;
typedef unsigned int 	DWORD;
typedef void (*HandlerType) (void);



#include "clock.h"
#include "interrupt.h"
#include "voltage.h"
#include "SPI.h"
#include "timer.h"
#include "ProgFlag.h"
#include "DMA.h"
#include "SPORT.h"
#include "UART.h"
#include "PPI.h"
#if (defined (__ADSPBF536__)||defined (__ADSPBF537__))
#include "EMAC.h"
#endif


//  
void DelayNs(DWORD NumNs);
void DelayMks(DWORD NumMks);
void DelayMs(DWORD NumMs);
void DelayCycles(DWORD CycleNumber);

void ReadSPIWords_asm(WORD * Data, WORD NumWords);
void WriteSPIWords_asm(WORD * Data, WORD NumWords);

void ReadSPIBytes_asm(BYTE * Data, WORD NumData);
void WriteSPIBytes_asm(BYTE * Data, WORD NumData);

WORD ReadSPI_asm(void);
void WriteSPI_asm(WORD Value);
WORD ExchangeSPI_asm(WORD Value);

void ReadAsync_asm(WORD * AsyncPtr, WORD *DataPtr, WORD NumBytes);
void WriteAsync_asm(WORD * AsyncPtr, WORD *DataPtr, WORD NumBytes);

DWORD GetDWORDFromAddr_asm(void * Pointer);
void SetDWORDToAddr_asm(void * Pointer, DWORD Value);
WORD GetWORDFromAddr_asm(void * Pointer);
void SetWORDToAddr_asm(void * Pointer, WORD Value);

#endif /*#ifndef HAL_H_*/
