#include <sys\platform.h>

.global _DelayNs;
.global _DelayMks;
.global _DelayMs;
.global _DelayCycles;
.global _ReadSPIBytes_asm;
.global _WriteSPIBytes_asm;

.global _ReadSPIWords_asm;
.global _WriteSPIWords_asm;

.global _ReadSPI_asm;
.global _WriteSPI_asm;
.global _ExchangeSPI_asm;

.global _ReadAsync_asm;
.global _WriteAsync_asm;

.global _GetDWORDFromAddr_asm;
.global _SetDWORDToAddr_asm;
.global _GetWORDFromAddr_asm;	
.global _SetWORDToAddr_asm;	

.extern _CurCoreClkHz;

.section L1_code;

_DelayNs:
	P0.l=lo(_CurCoreClkHz);P0.h=hi(_CurCoreClkHz);
	R1=[P0];
	R1=R1>>20; //   1048576 -      1 
	NOP;
	R0*=R1; //    		
	R0=R0>>10; //   		
	JUMP _DelayCycles;
_DelayMks:
	P0.l=lo(_CurCoreClkHz);P0.h=hi(_CurCoreClkHz);
	R1=[P0];
	R1=R1>>20; //   1048576 -      1 
	NOP;
	R0*=R1; //    		
	JUMP _DelayCycles;
_DelayMs:
	P0.l=lo(_CurCoreClkHz);P0.h=hi(_CurCoreClkHz);
	R1=[P0];
	R1*=R0; //    
	R0=R1>>10; //   1024 -      1 
_DelayCycles:
	R1=12;	//     
	CC = R0<R1;
	IF CC JUMP _DelayCycles.end;
	R0=R0-R1; //     		
	R0=R0>>1;
	P0=R0; NOP;NOP;NOP;NOP; //   4  	
	LSETUP(wait_start,wait_end) LC0=P0;
 	wait_start:  					
 	wait_end: 	NOP;NOP; 	
_DelayNs.end:_DelayMks.end:_DelayMs.end:_DelayCycles.end: RTS;


/*
  SPI  
*/
_ReadSPIBytes_asm:
	LINK 0;
	R2=P3;	
	R3=P4;
	
	R1=R1.l(Z); //   WORD
	P0=R0; //   
	P1=R1; //  
		
	P2.l = lo(SPI_TDBR);P2.h = hi(SPI_TDBR);	
	P3.l = lo(SPI_RDBR);P3.h = hi(SPI_RDBR);	
	P4.l = lo(SPI_STAT);P4.h = hi(SPI_STAT);
	
	R1.l=0xFFFF;	
	
	LSETUP(read_start_rSPIb,read_end_rSPIb) LC0=P1;
 	read_start_rSPIb:  	 	
	 	W[P2]=R1; 	 		
		return_wait_rSPIb:
			R0 = W[P4] (Z); 			
			CC=BITTST(R0, 5); //RXS
			IF !CC JUMP return_wait_rSPIb;
		R0.L = W[P3];					
 	read_end_rSPIb: B[P0++] = R0;
	
 	P4=R3;	
	P3=R2;
	UNLINK;
_ReadSPIBytes_asm.end: RTS;

/*
  SPI  
*/
_WriteSPIBytes_asm:
	LINK 0;
	R2 = P3;
	R3 = P4;	
	
	R1=R1.l(Z); //   WORD
	P0=R0; //   
	P1=R1; //  
			
	P2.l = lo(SPI_TDBR);P2.h = hi(SPI_TDBR);	
	P3.l = lo(SPI_RDBR);P3.h = hi(SPI_RDBR);	
	P4.l = lo(SPI_STAT);P4.h = hi(SPI_STAT);
	
	R1.l= 0xFFFF;		
	
	LSETUP(read_start_wSPIb,read_end_wSPIb) LC0=P1;
 	read_start_wSPIb: 	
 		R0=B[P0++] (Z);  		 		 		
	 	W[P2]=R0; 	
		return_wait_wSPIb:
			R0 = W[P4] (Z); 
			CC=BITTST(R0, 5); //RXS
			IF !CC JUMP return_wait_wSPIb;						
 	read_end_wSPIb:  R0 = W[P3](Z);
	
 	P4=R3;	
	P3=R2;
	UNLINK;	
_WriteSPIBytes_asm.end: RTS;

/*
  SPI  
*/
_ReadSPIWords_asm:
	LINK 0;
	R2=P3;	
	R3=P4;
	
	R1=R1.l(Z); //   WORD
	P0=R0; //   
	P1=R1; //  
		
	P2.l = lo(SPI_TDBR);P2.h = hi(SPI_TDBR);	
	P3.l = lo(SPI_RDBR);P3.h = hi(SPI_RDBR);	
	P4.l = lo(SPI_STAT);P4.h = hi(SPI_STAT);
	
	R1.l= 0xFFFF;	
	
	LSETUP(readw_start_rSPIb,readw_end_rSPIb) LC0=P1;
 	readw_start_rSPIb:  	 	
	 	W[P2]=R1; 	 		
		returnw_wait_rSPIb:
			R0 = W[P4] (Z); 
			CC=BITTST(R0, 5); //RXS
			IF !CC JUMP returnw_wait_rSPIb;
		R0 = W[P3](Z);					
 	readw_end_rSPIb: W[P0++] = R0;
	
 	P4=R3;	
	P3=R2;
	UNLINK;
_ReadSPIWords_asm.end: RTS;

/*
  SPI  
*/
_WriteSPIWords_asm:
	LINK 0;
	R2 = P3;
	R3 = P4;	
	
	R1=R1.l(Z); //   WORD
	P0=R0; //   
	P1=R1; //  
			
	P2.l = lo(SPI_TDBR);P2.h = hi(SPI_TDBR);	
	P3.l = lo(SPI_RDBR);P3.h = hi(SPI_RDBR);	
	P4.l = lo(SPI_STAT);P4.h = hi(SPI_STAT);
	
	R1.l= 0xFFFF;	
	
	LSETUP(readw_start_wSPIb,readw_end_wSPIb) LC0=P1;
 	readw_start_wSPIb: 	
 		R0=W[P0++] (Z);  		 		 		
	 	W[P2]=R0; 	
		returnw_wait_wSPIb:
			R0 = W[P4] (Z); 
			CC=BITTST(R0, 5); //RXS
			IF !CC JUMP returnw_wait_wSPIb;						
 	readw_end_wSPIb:  R0 = W[P3](Z);
	
 	P4=R3;	
	P3=R2;
	UNLINK;	
_WriteSPIWords_asm.end: RTS;


/*
 -   SPI   
*/
_ReadSPI_asm:
	R0.l = 0xFFFF;	
_ExchangeSPI_asm:_WriteSPI_asm:
	P0.l = lo(SPI_TDBR);P0.h = hi(SPI_TDBR);
	
	W[P0] = R0.l; //    WORD 
	
	P0.l = lo(SPI_STAT);P0.h = hi(SPI_STAT);
	
	return_wait_wSPI:
		R0 = W[P0] (Z); 
		CC=BITTST(R0, 5); //RXS
		IF !CC JUMP return_wait_wSPI;
		
	P0.l = lo(SPI_RDBR);P0.h = hi(SPI_RDBR);
	R0.l=W[P0];
_ExchangeSPI_asm.end:_WriteSPI_asm.end: _ReadSPI_asm.end:  RTS;



/*
      c 
*/
_ReadAsync_asm:
	P0=R0; 		// 
	P1=R1;		//   
	R0=R2>>1;	//  
	P2=R0;		//  
	
	CC=!BITTST(R1,0);
	if CC JUMP ReadAsyncWord; // destination   WORD
	SSYNC;
ReadAsyncByte:		
	LSETUP(readAsyncBStart,readAsyncBEnd) LC0=P2;
 	readAsyncBStart: 	
 		R0=W[P0] (Z); 
		B[P1++]=R0;
		R0>>=8; 		  			 			 			 				 		
 	readAsyncBEnd:  B[P1++]=R0;
 	
ReadAsyncWord:
	LSETUP(readAsyncWStart,readAsyncWEnd) LC0=P2;
 	readAsyncWStart: 	
 		R0=W[P0] (Z); 		
 	readAsyncWEnd:  W[P1++]=R0;
 	
 	CC=!BITTST(R2,0);
 	if CC JUMP _ReadAsync_asm.end;
 	R0=W[P0] (Z);
 	B[P1++]=R0;
 	
_ReadAsync_asm.end:  RTS;

/*
      c 
*/
_WriteAsync_asm:
	P0=R0; 		// 
	P1=R1;		//   
	R0=R2>>1;	//  
	P2=R0;		//  
	
	CC=!BITTST(R1,0);
	if CC JUMP WriteAsyncWord; // destination   WORD
	SSYNC;
WriteAsyncByte:		
	LSETUP(WriteAsyncBStart,WriteAsyncBEnd) LC0=P2;
 	WriteAsyncBStart: 	
 		R0=B[P1++](Z);
 		R1=B[P1++](Z);
 		R1=R1<<8;		
 		R0=R0|R1;
 	WriteAsyncBEnd:  W[P0]=R0;
 	
 	CC=!BITTST(R2,0);
 	if CC JUMP _WriteAsync_asm.end;
 	R0=B[P1] (Z);
 	W[P0]=R0; 	
    RTS;
 	
WriteAsyncWord:
	LSETUP(WriteAsyncWStart,WriteAsyncWEnd) LC0=P2;
 	WriteAsyncWStart: 	
 		R0=W[P1] (Z); 		
 	WriteAsyncWEnd:  W[P0]=R0;
 	
 	CC=!BITTST(R2,0);
 	if CC JUMP _WriteAsync_asm.end;
 	R0=B[P1] (Z);
 	W[P0]=R0;
 	
_WriteAsync_asm.end:  RTS;

/*
  ISP1583
PG_PINS_CLR(USBDevConf_PORTG_READY_WRITE_EDGE);            \
x;                                                         \
while(!(PG_PINS_DATA&USBDevConf_PORTG_READY_WRITE_EDGE));  \
ssync();                                                   \
while(!(PG_PINS_DATA&USBDevConf_PORTG_READY_WRITE_LEV));                               
*/
_WriteAsyncISP1583_asm:
	P0=R0; 		// 
	P1=R1;		//   
	R0=R2>>1;	//  
	P2=R0;		//  
	
	CC=!BITTST(R1,0);
	if CC JUMP WriteAsyncISP1583Word; // destination   WORD
	SSYNC;
WriteAsyncISP1583Byte:		
	LSETUP(WriteAsyncISP1583BStart,WriteAsyncISP1583BEnd) LC0=P2;
 	WriteAsyncISP1583BStart: 	
 		R0=B[P1++](Z);
 		R1=B[P1++](Z);
 		R1=R1<<8;		
 		R0=R0|R1;
 	WriteAsyncISP1583BEnd:  W[P0]=R0;
 	
 	CC=!BITTST(R2,0);
 	if CC JUMP _WriteAsyncISP1583_asm.end;
 	R0=B[P1] (Z);
 	W[P0]=R0;
 	RTS;
 	
WriteAsyncISP1583Word:
	LSETUP(WriteAsyncISP1583WStart,WriteAsyncISP1583WEnd) LC0=P2;
 	WriteAsyncISP1583WStart: 	
 		R0=W[P1] (Z); 		
 	WriteAsyncISP1583WEnd:  W[P0]=R0;
 	
 	CC=!BITTST(R2,0);
 	if CC JUMP _WriteAsyncISP1583_asm.end;
 	R0=B[P1] (Z);
 	W[P0]=R0;
 	
_WriteAsyncISP1583_asm.end:  RTS;


/*
	 !!!    DWORD (32 )   
	(     )   
	  4 (    ),  exception
	
	 WORD   -   
	  2
*/

_GetDWORDFromAddr_asm:
	P0=R0;
	ssync;
	R0=B[P0++](Z);
	R1=B[P0++](Z);
	R2=B[P0++](Z);
	R3=B[P0++](Z);
	
	R1<<=8;		
	R3<<=24;
	R0=R0|R1;
	R0.h=R2.l<<0;	
	R0=R0|R3;	
_GetDWORDFromAddr_asm.end: RTS;

_SetDWORDToAddr_asm:
	P0=R0;
	R0=R1;
	R1=R0>>8;
	R2=R0>>16;
	R3=R0>>24;
	B[P0]=R0;
	B[P0+1]=R1;
	B[P0+2]=R2;
	B[P0+3]=R3;
_SetDWORDToAddr_asm.end:RTS;

_GetWORDFromAddr_asm:
	P0=R0;
	ssync;
	R0=B[P0](Z);
	R1=B[P0+1](Z);		
	R1<<=8;			
	R0=R0|R1;	
_GetWORDFromAddr_asm.end: RTS;

_SetWORDToAddr_asm:
	P0=R0;
	R0=R1;
	R1=R0>>8;
	R2=R0>>16;
	R3=R0>>24;
	B[P0]=R0;
	B[P0+1]=R1;
_SetWORDToAddr_asm.end:RTS;