#ifndef PPI_H_
#define PPI_H_

 
typedef enum
    {
	PPI_rcv_ITU_R_656_ActiveFieldOnly=0,
	PPI_rcv_ITU_R_656_EntireField=1,
	PPI_rcv_ITU_R_656_VerticalBlankOnly=2,
	PPI_rcv_Non_ITU=3,
	PPI_tr_SyncLessOutput=0,
	PPI_tr_SyncOutput=3	
    } t_PPI_transfer_type;

typedef enum
    {
	PPI_rcv_1_ext_framesync=0,
	PPI_rcv_2_3_int_framesync=1,
	PPI_rcv_2_3_ext_framesync=2,
	PPI_rcv_0_framesync=3,
	PPI_tr_1_framesync=0,
	PPI_tr_2_3_framesync=1,
	PPI_tr_3_framesync=3
    } t_PPI_port_cfg;

typedef enum
    {
	PPI_ITU_tx_field_1=0,
	PPI_ITU_tx_fields_1_2=1,
	PPI_rx_ext_trigger=0,
	PPI_rx_int_trigger=1
    } t_PPI_active_trig;

typedef enum
    {
	e_PPI_data_8=0,
	e_PPI_data_9,
	e_PPI_data_10,
	e_PPI_data_11,
	e_PPI_data_12,
	e_PPI_data_13,
	e_PPI_data_14,
	e_PPI_data_15,
	e_PPI_data_16
    } t_PPI_data_length;

#define EnablePPI   *pPPI_CONTROL|=PORT_EN
#define DisablePPI   *pPPI_CONTROL&=~PORT_EN

void ConfigurePPI(  bool Transmit, 
                    t_PPI_transfer_type Tr_type, 
                    t_PPI_port_cfg port_cfg,
                    t_PPI_active_trig trig,
                    bool  Pack,
                    t_PPI_data_length data_length,
                    bool ClkFallingEdge,
                    bool FrameFallingEdge);
                    
void ConfPPITime(WORD PPIDelay, WORD PPICount, WORD PPIFrame);

#endif /*PPI_H_*/
