#ifndef PROGFLAG_H_
#define PROGFLAG_H_

#if defined (__ADSPBF533__)

#define SET_PF_PINS_DIRECTION(Mask) *pFIO_DIR=(Mask);*pFIO_INEN=~(Mask)
#define PF_PINS_INPUT_ENABLE  *pFIO_INEN

#define SET_PF_PIN_DIRECTION_OUT(PIN_Number)  *pFIO_DIR|=(1<<PIN_Number) 
#define SET_PF_PIN_DIRECTION_IN(PIN_Number)   *pFIO_DIR&=~(1<<PIN_Number) 


#define PF_PINS_DATA   			*pFIO_FLAG_D
#define PF_PINS_POLARITY   		*pFIO_POLAR
#define PF_PINS_EDGE   			*pFIO_EDGE

#define PF_PINS_PERIF_ENABLE(Mask)	*pFIO_FER|=Mask;ssync()
#define PF_PINS_PERIF_DISABLE(Mask)	*pFIO_FER&=~Mask;ssync()

#define PF_PINS_INTERRUPT_BOTH		*pFIO_BOTH

// ssync  ,        

#define PF_PINS_INTERRUPT_A_DATA		*pFIO_MASKA_D
#define PF_PINS_INTERRUPT_A_SET(Mask)	*pFIO_MASKA_S=Mask;ssync()
#define PF_PINS_INTERRUPT_A_CLR(Mask)	*pFIO_MASKA_C=Mask;ssync()
#define PF_PINS_INTERRUPT_A_TGL(Mask)	*pFIO_MASKA_T=Mask;ssync()

#define PF_PINS_INTERRUPT_B_DATA	        *pFIO_MASKB_D
#define PF_PINS_INTERRUPT_B_SET(Mask)		*pFIO_MASKB_S=Mask;ssync()
#define PF_PINS_INTERRUPT_B_CLR(Mask)		*pFIO_MASKB_C=Mask;ssync()
#define PF_PINS_INTERRUPT_B_TGL(Mask)		*pFIO_MASKB_T=Mask;ssync()

#define PF_PINS_CLR(Mask)    	*pFIO_FLAG_C=Mask;ssync()
#define PF_PINS_SET(Mask)    	*pFIO_FLAG_S=Mask;ssync()
#define PF_PINS_TOGGLE(MAsk)   	*pFIO_FLAG_T=Mask;ssync()

#define PF_PIN_CLEAR(PinNumber)    	(*pFIO_FLAG_C=1<<PinNumber);ssync()
#define PF_PIN_SET(PinNumber)   	(*pFIO_FLAG_S=1<<PinNumber);ssync()
#define PF_PIN_TOGGLE(PinNumber)   	(*pFIO_FLAG_T=1<<PinNumber);ssync()

#elif (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))
//------------------------------------------------------------------------
#define SWITCH_PORT_PERIF *pPORT_MUX
//------------------------------------------------------------------------
#define SET_PF_PINS_DIRECTION(Mask) *pPORTFIO_DIR=(Mask);*pPORTFIO_INEN=~(Mask)
#define PF_PINS_INPUT_ENABLE  *pPORTFIO_INEN

#define SET_PF_PIN_DIRECTION_OUT(PIN_Number)  *pPORTFIO_DIR|=(1<<PIN_Number) 
#define SET_PF_PIN_DIRECTION_IN(PIN_Number)   *pPORTFIO_DIR&=~(1<<PIN_Number) 


#define PF_PINS_DATA   			*pPORTFIO
#define PF_PINS_POLARITY   		*pPORTFIO_POLAR
#define PF_PINS_EDGE   			*pPORTFIO_EDGE

#define PF_PINS_PERIF_ENABLE(Mask)	*pPORTF_FER|=Mask;ssync()
#define PF_PINS_PERIF_DISABLE(Mask)	*pPORTF_FER&=~Mask;ssync()


#define PF_PINS_INTERRUPT_BOTH		*pPORTFIO_BOTH

// ssync  ,        

#define PF_PINS_INTERRUPT_A_DATA		*pPORTFIO_MASKA
#define PF_PINS_INTERRUPT_A_SET(Mask)	*pPORTFIO_MASKA_SET=Mask;ssync()
#define PF_PINS_INTERRUPT_A_CLR(Mask)	*pPORTFIO_MASKA_CLEAR=Mask;ssync()
#define PF_PINS_INTERRUPT_A_TGL(Mask)	*pPORTFIO_MASKA_TOGGLE=Mask;ssync()

#define PF_PINS_INTERRUPT_B_DATA	*pPORTFIO_MASKB
#define PF_PINS_INTERRUPT_B_SET(Mask)		*pPORTFIO_MASKB_SET=Mask;ssync()
#define PF_PINS_INTERRUPT_B_CLR(Mask)		*pPORTFIO_MASKB_CLEAR=Mask;ssync()
#define PF_PINS_INTERRUPT_B_TGL(Mask)		*pPORTFIO_MASKB_TOGGLE=Mask;ssync()

#define PF_PINS_CLR(Mask)    	*pPORTFIO_CLEAR=Mask;ssync()
#define PF_PINS_SET(Mask)    	*pPORTFIO_SET=Mask;ssync()
#define PF_PINS_TOGGLE(Mask)   	*pPORTFIO_TOGGLE=Mask;ssync()

#define PF_PIN_CLEAR(PinNumber)    	(*pPORTFIO_CLEAR=1<<PinNumber);ssync()
#define PF_PIN_SET(PinNumber)   	(*pPORTFIO_SET=1<<PinNumber);ssync()
#define PF_PIN_TOGGLE(PinNumber)   	(*pPORTFIO_TOGGLE=1<<PinNumber);ssync()

//--------------------------------------------------------------------------------
#define SET_PG_PINS_DIRECTION(Mask) *pPORTGIO_DIR=(Mask);*pPORTGIO_INEN=~(Mask)
#define PG_PINS_INPUT_ENABLE  *pPORTGIO_INEN

#define SET_PG_PIN_DIRECTION_OUT(PIN_Number)  *pPORTGIO_DIR|=(1<<PIN_Number) 
#define SET_PG_PIN_DIRECTION_IN(PIN_Number)   *pPORTGIO_DIR&=~(1<<PIN_Number) 


#define PG_PINS_DATA   			*pPORTGIO
#define PG_PINS_POLARITY   		*pPORTGIO_POLAR
#define PG_PINS_EDGE   			*pPORTGIO_EDGE

#define PG_PINS_PERIF_ENABLE(Mask) 	*pPORTG_FER|=Mask;ssync()
#define PG_PINS_PERIF_DISABLE(Mask)	*pPORTG_FER&=~Mask;ssync()

#define PG_PINS_INTERRUPT_BOTH		*pPORTGIO_BOTH

// ssync  ,        

#define PG_PINS_INTERRUPT_A_DATA		*pPORTGIO_MASKA
#define PG_PINS_INTERRUPT_A_SET(Mask)	*pPORTGIO_MASKA_SET=Mask;ssync()
#define PG_PINS_INTERRUPT_A_CLR(Mask)	*pPORTGIO_MASKA_CLEAR=Mask;ssync()
#define PG_PINS_INTERRUPT_A_TGL(Mask)	*pPORTGIO_MASKA_TOGGLE=Mask;ssync()

#define PG_PINS_INTERRUPT_B_DATA	*pPORTGIO_MASKB
#define PG_PINS_INTERRUPT_B_SET(Mask)		*pPORTGIO_MASKB_SET=Mask;ssync()
#define PG_PINS_INTERRUPT_B_CLR(Mask)		*pPORTGIO_MASKB_CLEAR=Mask;ssync()
#define PG_PINS_INTERRUPT_B_TGL(Mask)		*pPORTGIO_MASKB_TOGGLE=Mask;ssync()

#define PG_PINS_CLR(Mask)    	*pPORTGIO_CLEAR=Mask;ssync()
#define PG_PINS_SET(Mask)    	*pPORTGIO_SET=Mask;ssync()
#define PG_PINS_TOGGLE(MAsk)   	*pPORTGIO_TOGGLE=Mask;ssync()

#define PG_PIN_CLEAR(PinNumber)    	(*pPORTGIO_CLEAR=1<<PinNumber);ssync()
#define PG_PIN_SET(PinNumber)   	(*pPORTGIO_SET=1<<PinNumber);ssync()
#define PG_PIN_TOGGLE(PinNumber)   	(*pPORTGIO_TOGGLE=1<<PinNumber);ssync()	

//--------------------------------------------------------------------------------
#define SET_PH_PINS_DIRECTION(Mask) *pPORTHIO_DIR=(Mask);*pPORTHIO_INEN=~(Mask)
#define PH_PINS_INPUT_ENABLE  *pPORTHIO_INEN

#define SET_PH_PIN_DIRECTION_OUT(PIN_Number)  *pPORTHIO_DIR|=(1<<PIN_Number) 
#define SET_PH_PIN_DIRECTION_IN(PIN_Number)   *pPORTHIO_DIR&=~(1<<PIN_Number) 


#define PH_PINS_DATA   			*pPORTHIO
#define PH_PINS_POLARITY   		*pPORTHIO_POLAR
#define PH_PINS_EDGE   			*pPORTHIO_EDGE

#define PH_PINS_PERIF_ENABLE(Mask) 	*pPORTH_FER|=Mask;ssync()
#define PH_PINS_PERIF_DISABLE(Mask)	*pPORTH_FER&=~Mask;ssync()

#define PH_PINS_INTERRUPT_BOTH		*pPORTHIO_BOTH

// ssync  ,        

#define PH_PINS_INTERRUPT_A_DATA		*pPORTHIO_MASKA
#define PH_PINS_INTERRUPT_A_SET(Mask)	*pPORTHIO_MASKA_SET=Mask;ssync()
#define PH_PINS_INTERRUPT_A_CLR(Mask)	*pPORTHIO_MASKA_CLEAR=Mask;ssync()
#define PH_PINS_INTERRUPT_A_TGL(Mask)	*pPORTHIO_MASKA_TOGGLE=Mask;ssync()

#define PH_PINS_INTERRUPT_B_DATA	*pPORTHIO_MASKB
#define PH_PINS_INTERRUPT_B_SET(Mask)		*pPORTHIO_MASKB_SET=Mask;ssync()
#define PH_PINS_INTERRUPT_B_CLR(Mask)		*pPORTHIO_MASKB_CLEAR=Mask;ssync()
#define PH_PINS_INTERRUPT_B_TGL(Mask)		*pPORTHIO_MASKB_TOGGLE=Mask;ssync()

#define PH_PINS_CLR(Mask)    	*pPORTHIO_CLEAR=Mask;ssync()
#define PH_PINS_SET(Mask)    	*pPORTHIO_SET=Mask;ssync()
#define PH_PINS_TOGGLE(MAsk)   	*pPORTHIO_TOGGLE=Mask;ssync()

#define PH_PIN_CLEAR(PinNumber)    	(*pPORTHIO_CLEAR=1<<PinNumber);ssync()
#define PH_PIN_SET(PinNumber)   	(*pPORTHIO_SET=1<<PinNumber);ssync()
#define PH_PIN_TOGGLE(PinNumber)   	(*pPORTHIO_TOGGLE=1<<PinNumber);ssync()	
#endif

#endif /*#ifndef PROGFLAG_H_*/
