#ifndef SPI_H_
#define SPI_H_

#define SPIDIV *pSPI_BAUD

typedef enum 
{
	START_TRANS_WITH_READ=0x0,
	START_TRANS_WITH_WRITE=0x1,	    
	START_TRANS_WITH_DMA_READ=0x2,
	START_TRANS_WITH_DMA_WRITE=0x3
}SPI_TRANSFER_MOD_INIT;

typedef struct
    {
	WORD SPI_Control;
    WORD SPIFlag;
    WORD SPI_Baud;    
    } t_SPI_CONTROL_SET;


#define DisableSPI *pSPI_CTL&=~SPE;ssync()
#define EnableSPI *pSPI_CTL|=SPE

void ConfigureSPI(SPI_TRANSFER_MOD_INIT TransferInit,
				  bool SendLastWord,
				  bool OverwriteDataOnOverflow,
				  bool SlaveDetectEnable,
				  bool EnableMISO,
				  bool WordSize16Bit,
				  bool LSB1, 
				  bool CPHA1,  
				  bool CPOL1,
				  bool Master,
				  bool WriteOpenDrainMaster
				  );
				  
void ChangeSPI_TRansferMode(SPI_TRANSFER_MOD_INIT TransferInit);
				  
//    SPI -   SystemClk  0	
//   - Sclk/4
//    ,    25000000  30000000
void ConfigureSPIBaud(DWORD SpiClkHz);

//   -  SPI    
//   ,      
//  SPI,      
void DumpSPISettings(t_SPI_CONTROL_SET * SPI_CONTROL_SET);
void UnDumpSPISettings(t_SPI_CONTROL_SET * SPI_CONTROL_SET);

#define Select_CS_Slave(Mask) *pSPI_FLG=Mask|(1<<8)
#define Wait_SPI_Single_Word_Transfer_Complited while (!(*pSPI_STAT&SPIF))
#define Wait_SPI_RegistersReady while ((*pSPI_STAT&TXS)||!(*pSPI_STAT&RXS))
#define Clear_SPI_Stat_Error *pSPI_STAT=SPIF|TXCOL|RBSY|MODF|TXE
#define SPI_Data_Ready_Read (*pSPI_STAT&RXS)

WORD WriteSPI(WORD Data);
WORD ExchangeSPI(WORD Data);
WORD ReadSPI(void);
WORD WriteSPIBytes(BYTE * Data, WORD NumData);
void ReadSPIBytes(BYTE * Data, WORD NumData);

#endif /*#ifndef SPI_H_*/
