#include "HAL.h" 


void ConfigureSPORTTransmit(SPORT_CHANNEL channel,bool TransmitEnable, bool InternalClock, 
							SPORT_TRANSMIT_DATA_FORMAT DataFormat, bool LSBFirst,
							bool InternalFrames, bool FrameEveryDataWord,
							bool DataInDependFrame, bool ActiveLowFrame,
							bool LateFrameSync, bool InternFalingExternRising,
							SPORT_DATA_LENGTH DataLength, bool SecondaryEnabled,
							bool StereoFrameSync, bool RightStereoFirst							
							)
{
    *(WORD *)(SPORT0_TCR2+channel)=(RightStereoFirst<<10)|(StereoFrameSync<<9)|
    					(SecondaryEnabled<<8)|DataLength;
    
	*(WORD *)(SPORT0_TCR1+channel)=TransmitEnable|(InternalClock<<1)|(DataFormat<<2)|
								(LSBFirst<<4)|(InternalFrames<<9)|(FrameEveryDataWord<<10)|
								(DataInDependFrame<<11)|(ActiveLowFrame<<12)|(LateFrameSync<<13)|
								(InternFalingExternRising<<14);	
}

void ConfigureSPORTRecieve(SPORT_CHANNEL channel,bool TransmitEnable, bool InternalClock, 
							SPORT_RECIEVE_DATA_FORMAT DataFormat, bool LSBFirst,
							bool InternalFrames, bool FrameEveryDataWord,
							bool DataInDependFrame, bool ActiveLowFrame,
							bool LateFrameSync, bool InternFalingExternRising,
							SPORT_DATA_LENGTH DataLength, bool SecondaryEnabled,
							bool StereoFrameSync, bool RightStereoFirst							
							)
{
    *(WORD *)(SPORT0_RCR2+channel)=(RightStereoFirst<<10)|(StereoFrameSync<<9)|
    					(SecondaryEnabled<<8)|DataLength;
    
	*(WORD *)(SPORT0_RCR1+channel)=TransmitEnable|(InternalClock<<1)|(DataFormat<<2)|
								(LSBFirst<<4)|(InternalFrames<<9)|(FrameEveryDataWord<<10)|
								(DataInDependFrame<<11)|(ActiveLowFrame<<12)|(LateFrameSync<<13)|
								(InternFalingExternRising<<14);	
}

void SetSPORTClkTransmit(SPORT_CHANNEL channel, DWORD * ClkFreqHz, DWORD * FrameFreqHz)
{
 
    float Sport_Clk_divf=((float)(CurSystClkHz/(*ClkFreqHz*2)))-1; //-1 -      ,   
    WORD Sport_Clk_div = Sport_Clk_divf;
    if ((Sport_Clk_divf-Sport_Clk_div)>0.5f)Sport_Clk_div++;
    
    *ClkFreqHz=CurSystClkHz/(2*(Sport_Clk_div+1));
    
    WORD Sport_Frame_div=(*ClkFreqHz/(*FrameFreqHz)); //-1 -      ,   
    *FrameFreqHz=*ClkFreqHz/(Sport_Frame_div+1);    
    
     *(WORD *)(SPORT0_TCLKDIV+channel)=Sport_Clk_div;
     *(WORD *)(SPORT0_TFSDIV+channel)=Sport_Frame_div;
}

void SetSPORTClkRecieve(SPORT_CHANNEL channel, DWORD * ClkFreqHz, DWORD * FrameFreqHz)
{
 
    float Sport_Clk_divf=((float)(CurSystClkHz/(*ClkFreqHz*2)))-1; //-1 -      ,   
    WORD Sport_Clk_div = Sport_Clk_divf;
    if ((Sport_Clk_divf-Sport_Clk_div)>0.5) Sport_Clk_div++;
    
    *ClkFreqHz=(CurSystClkHz/(2*(Sport_Clk_div+1)));
    
    WORD Sport_Frame_div=(*ClkFreqHz/(*FrameFreqHz)); //-1 -      ,   
    *FrameFreqHz=*ClkFreqHz/(Sport_Frame_div+1);    
    
     *(WORD *)(SPORT0_RCLKDIV+channel)=Sport_Clk_div;
     *(WORD *)(SPORT0_RFSDIV+channel)=Sport_Frame_div;
}

void ResetSPORTTransmit(SPORT_CHANNEL channel)
{
    WORD LastValue =  *(WORD *)(SPORT0_TCR1+channel);   
    *(WORD *)(SPORT0_TCR1+channel)=0;   
    *(WORD *)(SPORT0_TCR1+channel)=LastValue;
}

void ResetSPORTRecieve(SPORT_CHANNEL channel)
{    
    WORD LastValue = (*(WORD *)(SPORT0_RCR1+channel));
    (*(WORD *)(SPORT0_RCR1+channel))=0;   
    (*(WORD *)(SPORT0_RCR1+channel))=LastValue;    
}

void WriteSPORT(SPORT_CHANNEL channel, WORD *Data, WORD Length)
{
    WORD * DataPointer=(WORD *)(SPORT0_TX+channel);
    WORD * StatPointer=(WORD *)(SPORT0_STAT+channel);
    
    while (Length--)
    {
        while(*StatPointer&TXF); // ,      FIFO
        *DataPointer=*Data++;
    }     
}

void ReadSPORT(SPORT_CHANNEL channel, WORD *Data, WORD Length)
{
    WORD * DataPointer=(WORD *)(SPORT0_RX+channel);
    WORD * StatPointer=(WORD *)(SPORT0_STAT+channel);
    
    while (Length--)
    {
        while(!(*StatPointer&RXNE)); // ,      FIFO
        *Data++=*DataPointer;
    }
}
