#ifndef SPORT_H_
#define SPORT_H_

typedef enum
{
   SPORT0_CHANNEL=0,
   SPORT1_CHANNEL=1*0x100
}SPORT_CHANNEL;

typedef enum
{
    Normal_Operation_Transmit,
    SPORT_RESERVED_Transmit,
    COMPAND_U_LAW_T,
    COMPAND_A_LAW_T
}SPORT_TRANSMIT_DATA_FORMAT;

typedef enum
{
    Zero_Fill_Recieve,
    Sign_Extend_Recieve,
    COMPAND_U_LAW_R,
    COMPAND_A_LAW_R
}SPORT_RECIEVE_DATA_FORMAT;

typedef enum
{    
    SLEN_3=2,
    SLEN_4=3,
    SLEN_5=4,
    SLEN_6=5,
    SLEN_7=6,
    SLEN_8=7,
    SLEN_9=8,
    SLEN_10=9,
    SLEN_11=10,
    SLEN_12=11,
    SLEN_13=12,
    SLEN_14=13,
    SLEN_15=14,
    SLEN_16=15,
    SLEN_17=16,
    SLEN_18=17,
    SLEN_19=18,
    SLEN_20=19,
    SLEN_21=20,
    SLEN_22=21,
    SLEN_23=22,
    SLEN_24=23,
    SLEN_25=24,
    SLEN_26=25,
    SLEN_27=26,
    SLEN_28=27,
    SLEN_29=28,
    SLEN_30=29,
    SLEN_31=30,
    SLEN_32=31   
}SPORT_DATA_LENGTH;

#define Set_SPORT_Finish_Transmit(channel)	((*(WORD *)(SPORT0_STAT+channel))|=TXHRE)
#define SPORT_Finish_Transmit(channel)	((*(WORD *)(SPORT0_STAT+channel))&TXHRE)

#define DisableSPORTTransmit(channel) (*(WORD *)(SPORT0_TCR1+channel))&=~TSPEN;ssync()
#define EnableSPORTTransmit(channel) (*(WORD *)(SPORT0_TCR1+channel))|=TSPEN

#define DisableSPORTRecieve(channel) (*(WORD *)(SPORT0_RCR1+channel))&=~RSPEN;ssync()
#define EnableSPORTRecieve(channel) (*(WORD *)(SPORT0_RCR1+channel))|=RSPEN


void ConfigureSPORTTransmit(SPORT_CHANNEL channel,bool TransmitEnable, bool InternalClock, 
							SPORT_TRANSMIT_DATA_FORMAT DataFormat, bool LSBFirst,
							bool InternalFrames, bool FrameEveryDataWord,
							bool DataInDependFrame, bool ActiveLowFrame,
							bool LateFrameSync, bool InternFalingExternRising,
							SPORT_DATA_LENGTH DataLength, bool SecondaryEnabled,
							bool StereoFrameSync, bool RightStereoFirst							
							);
void ConfigureSPORTRecieve(SPORT_CHANNEL channel,bool TransmitEnable, bool InternalClock, 
							SPORT_RECIEVE_DATA_FORMAT DataFormat, bool LSBFirst,
							bool InternalFrames, bool FrameEveryDataWord,
							bool DataInDependFrame, bool ActiveLowFrame,
							bool LateFrameSync, bool InternFalingExternRising,
							SPORT_DATA_LENGTH DataLength, bool SecondaryEnabled,
							bool StereoFrameSync, bool RightStereoFirst							
							);							

void SetSPORTClkTransmit(SPORT_CHANNEL channel, DWORD * ClkFreqHz, DWORD * FrameFreqHz);
void SetSPORTClkRecieve(SPORT_CHANNEL channel, DWORD * ClkFreqHz, DWORD * FrameFreqHz);
void WriteSPORT(SPORT_CHANNEL channel, WORD *Data, WORD Length);
void ReadSPORT(SPORT_CHANNEL channel, WORD *Data, WORD Length);
void ResetSPORTTransmit(SPORT_CHANNEL channel);
void ResetSPORTRecieve(SPORT_CHANNEL channel);

#endif /*#ifndef SPORT_H_*/
