#include "HAL.h"



void ConfigureUART(t_UART_Data_Bits UART_Data_Bits, t_UART_Stop_Bits UART_Stop_Bits,
					t_UART_Parity_Type UART_Parity_Type)
{       
    *pUART0_LCR = (UART_Data_Bits)|(UART_Stop_Bits<<2)|(UART_Parity_Type<<3);
}

void ConfigureUART_Interrupt(bool RecieveInt, bool TransmitInt, bool ErrorInt)
{
    *pUART0_IER = RecieveInt|(TransmitInt<<1)|(ErrorInt<<2);
}

void SetUARTBaudRate(DWORD BaudRate)
{
    float Dividerf = (float)CurSystClkHz/(16*BaudRate);
    WORD Div = Dividerf;
    if ((Dividerf-Div)>0.5f)Div++;    
    
    WORD LastValue = *pUART0_LCR;
    WORD LastControl = *pUART0_GCTL;
    WORD LastInterrupt = *pUART0_IER;
    
    DisableUART_Clock;
    
    *pUART0_LCR=DLAB; //  UART        BaudRate
    ssync();
    *pUART0_DLL = Div;
    *pUART0_DLH = Div>>8;        
    
    *pUART0_LCR = LastValue;
    *pUART0_IER = LastInterrupt;
    ssync();
    *pUART0_GCTL = LastControl;
    ssync();
}

BYTE ReadUART(void)
{
    while (!UART_READY_READ); // ,    
    return *pUART0_RBR;
}

void WriteUART(BYTE Value)
{
    while (!UART_READY_WRITE);
    *pUART0_THR = Value;
}

