#ifndef UART_H_
#define UART_H_


typedef enum
    {
    UART_DATA5=0,
    UART_DATA6,
    UART_DATA7,
    UART_DATA8
    } t_UART_Data_Bits;

typedef enum
    {
    UART_STOP1=0,
    UART_STOP2_OR_HALF
    } t_UART_Stop_Bits;
 
typedef enum 
    {
    UART_PARITY_NONE=0,
    UART_PARITY_ODD=1,
    UART_PARITY_EVEN = 3
    } t_UART_Parity_Type;

#if defined (__ADSPBF533__)
#define pUART0_LCR pUART_LCR
#define pUART0_DLL pUART_DLL
#define pUART0_DLH pUART_DLH
#define pUART0_IER pUART_IER
#define pUART0_GCTL pUART_GCTL
#define pUART0_THR pUART_THR
#define pUART0_RBR pUART_RBR
#define pUART0_GCTL pUART_GCTL
#define pUART0_LSR pUART_LSR
#elif (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))
#endif

#define UART_READY_READ	(*pUART0_LSR&DR)
#define UART_READY_WRITE	(*pUART0_LSR&THRE)
#define UART_WRITE_COMPLITED	(*pUART0_LSR&TEMT)
#define UART_TRANSFER_ERROR		(*pUART0_LSR&(OE|PE|FE))

#define EnableUART_Clock	*pUART0_GCTL|=UCEN;ssync()
#define DisableUART_Clock	*pUART0_GCTL&=~UCEN;ssync()


void ConfigureUART(t_UART_Data_Bits UART_Data_Bits, t_UART_Stop_Bits UART_Stop_Bits,
					t_UART_Parity_Type UART_Parity_Type);
void SetUARTBaudRate(DWORD BaudRate);
void ConfigureUART_Interrupt(bool RecieveInt, bool TransmitInt, bool ErrorInt);					
BYTE ReadUART(void);
void WriteUART(BYTE Value);

#endif /*#ifndef UART_H_*/
