#ifndef CLOCK_H_
#define CLOCK_H_

extern DWORD CurCoreClkHz;
extern DWORD CurSystClkHz;
extern DWORD CurPLLClkHz;
extern DWORD CurQuartzClkHz;

#define SET_SDRAM_SELF_REFRESH *pEBIU_SDGCTL|=SRFS;ssync()
#define CLR_SDRAM_SELF_REFRESH *pEBIU_SDGCTL&=~SRFS;ssync()

void InitializeQuartz(DWORD QuartzFreqHz);
int GetCoreClkDiv(void);
WORD Set_PLL(bool Bypass,bool DivF, BYTE MultSEL, DWORD QuartzFreq);
WORD SetSystemAndCoreCLKDiv(BYTE SystemCLK_divider, BYTE CoreCLK_divider);
WORD Set_Pll_PowerManagement(bool PllOff, bool StopClock, bool PowerDown,
							bool InputDelay, bool OutputDelay);

void Idle_State(DWORD WakeUpReason, bool SDRAM_Sleep);
							
void Put_SDRAM_Into_SelfRefresh(void);
WORD Get_SDRAM_From_SelfRefresh(void);

void SystemReset(bool NoBoot);

#if (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))
void EnableClkBufOut(void);
#endif

#endif /*#ifndef CLOCK_H_*/

