#include "HAL.h"


/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void SetInterruptIVG_Perif
    (
    INTERRUPT_SOURCE Source,
    INTERRUPT_IVG Ivg
    )
    {
    DWORD Data;
    WORD NumShiftData = (Source & 0x07) << 2;       /*   4    */    	
	DWORD *pIntReg = (DWORD *)(SIC_IAR0 + ((Source >> 1) & ~0x03));
		
	Data = *pIntReg;
	Data &= ~(0x0F << NumShiftData);
	Data |= Ivg << NumShiftData;
	*pIntReg = Data;
	/*  ssync      - anomaly */
	Data = *pIntReg;
	ssync();
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void Set_Enable_InterruptIVG_Perif(INTERRUPT_SOURCE Source, INTERRUPT_IVG Ivg, 
						void (*newHandler) () )
{
    SetInterruptIVG_Perif(Source, Ivg);
    Enable_Interrupt_Perif(Source);        
    register_handler_ex((interrupt_kind)(Ivg+7), newHandler,EX_INT_ENABLE);   
}
/*------------------------------------------------------------------------------------------------*/

void Set_InterruptIVG_Perif(INTERRUPT_SOURCE Source, INTERRUPT_IVG Ivg, 
						void (*newHandler) () )
{
    SetInterruptIVG_Perif(Source, Ivg);    
    register_handler_ex((interrupt_kind)(Ivg+7), newHandler,EX_INT_ENABLE);   
}

void Enable_Interrupt_Core(interrupt_kind Source)
{
    WORD Data = *pIMASK;
    Data|=(1<<Source);
    *pIMASK=Data;   
    ssync(); 
}

void Disable_Interrupt_Core(interrupt_kind Source)
{   
    WORD Data = *pIMASK;
    Data&=~(1<<Source);
    *pIMASK=Data; 
    Data=*pIMASK;//  ssync      - anomaly       
    ssync();
}

void SetAllInterruptsDefaultHandler(void)
{
    int i;
    for (i=5;i<16;i++)
    {
        register_handler_ex((interrupt_kind)i, EX_INT_DEFAULT, EX_INT_DISABLE); 
    }
}

void ResetPerifDefaultIVG(void)
{
    *pSIC_IAR0=0x88888888;
    *pSIC_IAR1=0x88888888;
    *pSIC_IAR2=0x88888888; 
#if (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))    
    *pSIC_IAR3=0x88888888;      
#endif
}

DWORD Enable_Interrupt_Perif(INTERRUPT_SOURCE Source)
{
     *pSIC_IMASK|=(1<<Source);
     DWORD TempValue=*pSIC_IMASK;//  ssync      - anomaly       
     ssync();
     return TempValue;
}

DWORD Disable_Interrupt_Perif(INTERRUPT_SOURCE Source)
{
     *pSIC_IMASK&=~(1<<Source);
     DWORD TempValue=*pSIC_IMASK;//  ssync      - anomaly       
     ssync();
     return TempValue;
}

DWORD Clear_Interrupt_Perif(INTERRUPT_SOURCE Source)
{
     *pSIC_ISR&=~(1<<Source);
     DWORD TempValue=*pSIC_ISR;//  ssync      - anomaly       
     ssync();
     return TempValue;
}
/*================================================================================================*/

