#ifndef INTERRUPT_H_
#define INTERRUPT_H_

#define disable_interrupt cli();ssync()
#define enable_interrupt(ImaskValue) sti(ImaskValue)

//   DMA   ,    DMA 
//        

typedef enum 
{
#if defined (__ADSPBF533__)
	PLL_Wakeup_Interrupt	=0,
	DMA_Error_Interrupt		=1,
    PPI_Error_Interrupt		=2,
    SPORT0_Error_Interrupt	=3,
    SPORT1_Error_Interrupt	=4,
    SPI_Error_Interrupt		=5,
    UART_Error_Interrupt	=6,
    Real_Time_Clock_Interrupt=7,
    DMA0_PPI_Interrupt		=8,
    DMA1_SPORT0_RX_Interrupt=9,
    DMA2_SPORT0_TX_Interrupt=10,
    DMA3_SPORT1_RX_Interrupt=11,
    DMA4_SPORT1_TX_Interrupt=12,
    DMA5_SPI_Interrupt		=13,
    DMA6_UART_RX_Interrupt	=14,
    DMA7_UART_TX_Interrupt	=15,
    Timer_0_Interrupt		=16,
    Timer_1_Interrupt		=17,
    Timer_2_Interrupt		=18,
    PF_A_Interrupt			=19,
    PF_B_Interrupt			=20,
    Memory_DMA_Stream_0_Interrupt=21,
    Memory_DMA_Stream_1_Interrupt=22,
    Software_Watchdog_Timer_Interrupt=23
#elif (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))
	PLL_Wakeup_Interrupt		=0,
	DMA_Error_Interrupt			=1,
	Peripheral_Error_Interrupt	=2,
    Real_Time_Clock_Interrupt	=3,
    DMA0_PPI_Interrupt			=4,
    DMA3_SPORT0_RX_Interrupt	=5,
    DMA4_SPORT0_TX_Interrupt	=6,
    DMA5_SPORT1_RX_Interrupt	=7,
    DMA6_SPORT1_TX_Interrupt	=8,
    TWI_IVG10_Interrupt			=9,
    DMA7_SPI_Interrupt			=10,
    DMA8_UART0_RX_Interrupt		=11,
    DMA9_UART0_TX_Interrupt		=12,
    DMA10_UART1_RX_Interrupt	=13,
    DMA11_UART1_TX_Interrupt	=14,
    CAN_RX_Interrupt			=15,
    CAN_TX_Interrupt			=16,
    DMA1_MAC_RX_PHA_Interrupt	=17,
    DMA2_MAC_TX_PHB_Interrupt	=18,
    Timer0_Interrupt			=19,
    Timer1_Interrupt			=20,
    Timer2_Interrupt			=21,
    Timer3_Interrupt			=22,
    Timer4_Interrupt			=23,
    Timer5_Interrupt			=24,
    Timer6_Interrupt			=25,
    Timer7_Interrupt			=26,
    PortF_G_A_Interrupt			=27,
    PortG_B_Interrupt			=28,
    Memory_DMA_Stream_0_Interrupt=29,
    Memory_DMA_Stream_1_Interrupt=30,
    Software_Watchdog_Timer_Interrupt=31,
    PortF_B_Interrupt			=31
#endif
}INTERRUPT_SOURCE;


typedef enum 
{
	IVG7=0,
	IVG8,
	IVG9,
	IVG10,
	IVG11,
	IVG12,
	IVG13,
	IVG14,
	IVG15	
}INTERRUPT_IVG;

#define Set_Enable_Interrupt_Core(Source, Handler, EnableInterrupt) register_handler_ex(Source, Handler, EnableInterrupt);
void SetAllInterruptsDefaultHandler(void);
void ResetPerifDefaultIVG(void);
void Disable_Interrupt_Core(interrupt_kind Source);
void Enable_Interrupt_Core(interrupt_kind Source);


void SetInterruptIVG_Perif(INTERRUPT_SOURCE Source, INTERRUPT_IVG Ivg);
void Set_Enable_InterruptIVG_Perif(INTERRUPT_SOURCE Source, INTERRUPT_IVG Ivg, 
						void (*newHandler) () );
void Set_InterruptIVG_Perif(INTERRUPT_SOURCE Source, INTERRUPT_IVG Ivg, 
						void (*newHandler) () );	
											
DWORD Enable_Interrupt_Perif(INTERRUPT_SOURCE Source);
DWORD Disable_Interrupt_Perif(INTERRUPT_SOURCE Source);
DWORD Clear_Interrupt_Perif(INTERRUPT_SOURCE Source);

#endif /*#ifndef INTERRUPT_H_*/
