#ifndef TIMER_H_
#define TIMER_H_

typedef enum 
{
  TIMER_PWM_OUT=PWM_OUT,
  TIMER_WDTH_CAP=WDTH_CAP,
  TIMER_EXT_CLK=EXT_CLK
}TIMERS_MODE;

typedef enum 
    {
    TIMER0=0,
    TIMER1=1,
    TIMER2=2
#if (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))
	,TIMER3=3,
	TIMER4=4,
	TIMER5=5,
	TIMER6=6,
	TIMER7=7,
#endif
    } t_TIMERS;

#define SetCounter(Timers, Value) *(DWORD *)(TIMER0_COUNTER+(Timers*0x10))=Value
#define EnableTimers(Timers) *pTIMER_ENABLE=(1<<Timers)
#define DisableTimers(Timers) *pTIMER_DISABLE=(1<<Timers)
#define DisableTimersImmediately(Timers) *pTIMER_DISABLE=(1<<Timers);*pTIMER_STATUS|=((1<<Timers)<<12);ssync()

#if (defined (__ADSPBF534__)||defined (__ADSPBF536__)||defined (__ADSPBF537__))
inline void ClearInterruptStatus(t_TIMERS Timer)
{
    WORD Shift=0;
    if (Timer>=4) Shift=12;
    	*pTIMER_STATUS = ((1<<Timer)<<Shift);    
}

inline void ClearOverflowStatus(t_TIMERS Timer)
{
    WORD Shift=0;
    if (Timer>=4) Shift=12;
    
    *pTIMER_STATUS = ((1<<Timer)<<(4+Shift));
}

inline bool GetOverflowStatus(t_TIMERS Timer)
{
    WORD Shift=0;
    if (Timer>=4) Shift=12;
    return (*pTIMER_STATUS&((1<<Timer)<<(4+Shift)));
}
#else
#define ClearOverflowStatus(Timers)	*pTIMER_STATUS|=((1<<Timers)<<4)
#define ClearInterruptStatus(Timers)	*pTIMER_STATUS|=(1<<Timers);ssync()
#define GetOverflowStatus(Timers)	(*pTIMER_STATUS&((1<<Timers)<<4))
#endif

void ConfigureTimer(t_TIMERS Timer, TIMERS_MODE Mode,  
					bool PositivePulse, bool Period_Counter, 
					bool Interrupt_Req_Enable, bool Timer_Input_UART, 
					bool Disable_Pad, bool Use_PWM_Clock_for_Counter, 
					bool Toggle_Puls_PWM
			);
			
void ConfiGureTimerPeriodAndWidth(t_TIMERS Timer, 
				DWORD Period, DWORD Width);

#endif /*#ifndef TIMER_H_*/
