#include "HAL.h"

void SetNewVoltage(	CORE_VOLTAGE_VALUES Value,
					CORE_VOLTAGE_CHANGE_FREQ Freq, 
					CORE_VOLTAGE_GAIN Gain)
{   
    int InterruptLatch;	   	
    
    CORE_VOLTAGE_VALUES LastValue =(CORE_VOLTAGE_VALUES)((*pVR_CTL>>4)&0xF);
    
    if (LastValue>Value)
    {
        Freq=VOL_FREQ_333_kHz;
        Gain=VOL_GAIN_20;
        *pPLL_LOCKCNT=0x600; //    		
    }
    else
    {
    
    	*pPLL_LOCKCNT=0x200; //    		
    }
    
    InterruptLatch=disable_interrupt;       
    
    *pVR_CTL=Freq|(Gain<<2)|(Value<<4);
    ssync();    	
    
    idle(); 
    
    enable_interrupt(InterruptLatch);   
}

CORE_VOLTAGE_VALUES GetCurCoreVoltage(void)
{
    WORD Data = *pVR_CTL;
    return (CORE_VOLTAGE_VALUES) ((Data>>4)&0xF);
}
