#ifndef VOLTAGE_H_
#define VOLTAGE_H_

typedef enum
{
    VOL_0_85=	6,
    VOL_0_90=	7,
    VOL_0_95=	8,
    VOL_1_00=	9,
    VOL_1_05=	10,
    VOL_1_10=	11,
    VOL_1_15=	12,
    VOL_1_20=	13    
}CORE_VOLTAGE_VALUES;

typedef enum
{
    VOL_FREQ_POWER_DOWN_BYPASS_ONBOARD_REG=	0,    
    VOL_FREQ_333_kHz=						1,
    VOL_FREQ_667_kHz=						2,
    VOL_FREQ_1_MHz=							3
}CORE_VOLTAGE_CHANGE_FREQ;

typedef enum
{
    VOL_GAIN_5=								0,
    VOL_GAIN_10=							1,
    VOL_GAIN_20=							2,
    VOL_GAIN_50=							3
}CORE_VOLTAGE_GAIN;

void SetNewVoltage(	CORE_VOLTAGE_VALUES Value,
					CORE_VOLTAGE_CHANGE_FREQ Freq, 
					CORE_VOLTAGE_GAIN Gain);
CORE_VOLTAGE_VALUES GetCurCoreVoltage(void);

#endif /*#ifndef VOLTAGE_H_*/
