#ifndef ALTERA_H_
#define ALTERA_H_


/*================================================================================================*/
#define ALTERA_BROACHING_FLASH_START_ADDRESS (0x1E7000)
#define AlteraMaxBurnFreq (100 * 1000000)
#define AlteraMaxWorkFreq (100 * 1000000)

#define ALTERA_REGS_NUMBER (16)

#define ALTERA_RESET_REG (0x00)
#define ALTERA_TEST_RING_REG (0x01)
#define ALTERA_MODULE_SPEED_LO (0x02)
#define ALTERA_MODULE_SPEED_HI (0x03)
#define ALTERA_MODULE_PRES_LO (0x04)
#define ALTERA_MODULE_PRES_HI (0x05)
#define ALTERA_TEST_REG (0x07)
#define ALTERA_LED_REG (0x08)


#define CloseAlteraInterface() UnDumpSPISettingsStore()
/*================================================================================================*/

/*================================================================================================*/
struct altera_register
    {
    t_uint16 value;
    int is_updated;
    };

typedef enum
    {
    LED_No = 0x03,
    LED_Red = 0x02,
    LED_Green = 0x01,
    LED_Multi = 0	
    } t_AlteraLedType;
/*================================================================================================*/

/*================================================================================================*/
BYTE AlteraReadCommand(WORD Address);
bool AlteraTest(void);
void AlteraWriteCommand(WORD Address, WORD Data);
bool BurnAltera(BYTE *Data, DWORD NumData);
void CloseAlteraForBurn(void);
DWORD LoadAlteraBroachingFromFlash(BYTE *Data);  /*   65  */
void OpenAlteraForBurn(void);
void OpenAlteraInterface(void);
void SetAlteraLed(t_AlteraLedType AlteraLedType);
/*================================================================================================*/

/*================================================================================================*/
extern struct altera_register g_altera_reg[ ALTERA_REGS_NUMBER ];
/*================================================================================================*/


#endif /*#ifndef ALTERA_H_*/
