#include "GlobDefs.h"
#include "hardware.h"
#include <stddef.h>


/*================================================================================================*/
static void f_StartReadPPI_DMA(void);
/*================================================================================================*/

/*================================================================================================*/
t_AlteraDataStruct *AlteraDev;
segment ("sdram0_bank2") WORD PPI_Recv_Data[ PPI_Recv_Data_Size_Word ];
segment ("sdram0_bank3") WORD SPORT_Tran_Data[ SPORT_Transmit_Data_Size_Word ];//+512];	// !!!
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
//EX_INTERRUPT_HANDLER( AlteraInterfaceSPORTInterrupt )
void vIVG10_handle(void)
    {
    WORD PGStatus;
    	
    if (AlteraDev->SPORT_Running)
	    {
	    if ((*pDMA4_IRQ_STATUS & (DMA_DONE | DMA_RUN | DFETCH)) == DMA_DONE)
    	    {
    	    /* DMA  */
    	    /*    */
	   		*pDMA4_IRQ_STATUS = DMA_DONE;
	    	AlteraDev->SPORT_Running = false;	         		   		      		    	
    		PG_PINS_INTERRUPT_B_SET( AlteraDev->WRITE_PERM_FLAG_G );
    	    }
	    }
	
	PGStatus = PG_PINS_DATA;
	PGStatus &= PG_PINS_INTERRUPT_B_DATA;
	
	if (PGStatus & AlteraDev->WRITE_PERM_FLAG_G)
	    {
	    PG_PINS_INTERRUPT_B_CLR( AlteraDev->WRITE_PERM_FLAG_G );
	    
	    if (AlteraDev->LastSndSize > 0)
	        {
	        unsigned buf_block_size;
	            
	        AlteraDev->SndBufAvail += AlteraDev->LastSndSize * 2;
	        
            AlteraDev->CurSndBufferPtrProcessed = AlteraDev->WRITE_SPORT.DataPointer -
                SPORT_Tran_Data;
	        
            buf_block_size = (g_device_mode == e_DeviceMode_USB) ?
                ltr030Conf.USBDev.MaxBulkSize: ETH_DATAPART;
                
            if (   !ltr030Conf.USBDev.ep2rxEn
                && (AlteraDev->SndBufAvail >= buf_block_size)
               )
                {
                ltr030Conf.USBDev.ep2rxEn = 1;
                //AccessISPRegWrite( ISP1583.D14_INT_ENABLE.VALUE |= (1U << 14) );
                }
        
	        AlteraDev->LastSndSize = 0;
	        }
	    
	    if (AlteraDev->WRITE_SPORT.DataCounter == 0)
	        {
	        unsigned long buf_remaind;
            DWORD NumDataReady;
            
	        
	        NumDataReady = SPORT_Transmit_Data_Size_Word - AlteraDev->SndBufAvail / 2;
	        
            /*    4  */
	        NumDataReady &= 0xFFFFFFFE;
	        
	        if (NumDataReady > 0)
	            {
	        	AlteraDev->WRITE_SPORT.DataCounter = NumDataReady;   
                AlteraDev->WRITE_SPORT.DataPointer =
                    &SPORT_Tran_Data[ AlteraDev->CurSndBufferPtrProcessed ];
	        	//AlteraDev->LastSndSize = NumDataReady;
	            }
	        } /*if (AlteraDev->WRITE_SPORT.DataCounter == 0)*/
	        
	    if (AlteraDev->WRITE_SPORT.DataCounter > 0)
	        {
	        ptrdiff_t buf_remaind;
            WORD NumData = min( AlteraDev->WRITE_SPORT.DataCounter, MaxSPORT_DMA_Size_WORD );
	        
            buf_remaind = &SPORT_Tran_Data[ SPORT_Transmit_Data_Size_Word ] -
                AlteraDev->WRITE_SPORT.DataPointer;
            if (NumData > buf_remaind)
                NumData = buf_remaind;

	        if (!SPORT_Finish_Transmit( AlteraDev->SPORT_Ch ))
	            {
                /*      SPORT !!! */
                while (!SPORT_Finish_Transmit( AlteraDev->SPORT_Ch ))
                    {
                    continue;
                    }
                /*  hold register ,      ,   
                 * 
                 */
	        	//DelayNs( 300 );
	            }
	        
    		ConfigureDMAChannelRegAndStart( AlteraDev->SPORT_tr_DMAChannel,
    		    (DWORD)AlteraDev->WRITE_SPORT.DataPointer, NumData );
    		
			if (!AlteraDev->SPORT_Enabled)
    		    {
				EnableSPORTTransmit( AlteraDev->SPORT_Ch );
    			AlteraDev->SPORT_Enabled = true;
    		    }
   		
    		AlteraDev->LastSndSize = NumData;
    		
    		
    		AlteraDev->WRITE_SPORT.DataCounter -= NumData;
    		if (NumData < buf_remaind) AlteraDev->WRITE_SPORT.DataPointer += NumData;
            else                       AlteraDev->WRITE_SPORT.DataPointer = SPORT_Tran_Data;
    		
    		AlteraDev->SPORT_Running = true;
    		AlteraDev->AlteraSPORTReady = false;   
	        }
	    else
	        {
	        /*   */
	        AlteraDev->AlteraSPORTReady = true;
	        }
	    } /*if (PGStatus&AlteraDev->WRITE_PERM_FLAG_G)*/
	
	if (PGStatus & AlteraDev->NEW_MODULE_FLAG_G)
	    {
	    /*      */
		PG_PINS_CLR( AlteraDev->NEW_MODULE_FLAG_G );
		if (!g_power_on && !g_ring_mode)
	        AlteraDev->NewModulesAppearence = true;
	    }
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
bool AlteraSPORTReady
    (
    void
    )
    {
    if (AlteraDev->WRITE_SPORT.DataCounter > 0)
        return false;
    if (!(PG_PINS_DATA & AlteraDev->WRITE_PERM_FLAG_G))
        return false;
    return !AlteraDev->SPORT_Running;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void CloseAlteraDataInterface
    (
    void
    )
    {
    AlteraDev->Opened = false;
    ResetSPORT();
    DisablePPI;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void CommitDataFromPPIBuffer
    (
    DWORD NumDataWord
    )
    {
    AlteraDev->CurRecvBufPtrProcesed += NumDataWord;
    if (AlteraDev->CurRecvBufPtrProcesed >= PPI_Recv_Data_Size_Word)
        AlteraDev->CurRecvBufPtrProcesed -= PPI_Recv_Data_Size_Word;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void CommitDataFromSPORTBuffer
    (
    DWORD NumDataWord
    )
    {
    int CurSndBufferPtrLast = AlteraDev->CurSndBufferPtr;    	
    unsigned i;
    
    /*        */
    AlteraDev->CurSndBufferPtr += NumDataWord;
    if (AlteraDev->CurSndBufferPtr >= SPORT_Transmit_Data_Size_Word)
        {
        AlteraDev->CurSndBufferPtr -= SPORT_Transmit_Data_Size_Word;
        /*     SPORT */
        if (CurSndBufferPtrLast < AlteraDev->CurSndBufferPtrProcessed)
            {
            AlteraDev->OverflowBuffersEvent = true;
            }
        else if (AlteraDev->CurSndBufferPtr > AlteraDev->CurSndBufferPtrProcessed)
            {
            AlteraDev->OverflowBuffersEvent = true;
            }
        }
    else
        {
        /*     SPORT */
        if (   (CurSndBufferPtrLast < AlteraDev->CurSndBufferPtrProcessed)
            && (AlteraDev->CurSndBufferPtr > AlteraDev->CurSndBufferPtrProcessed)
           )
            {
            AlteraDev->OverflowBuffersEvent = true;
            }
        }
    /*   ,          */
    if (USBDevConf->BufferRemaind)
        {
        for (i = 0; (i < USBDevConf->BufferRemaind); i++)
            {
            SPORT_Tran_Data[ i ] = SPORT_Tran_Data[ SPORT_Transmit_Data_Size_Word+i ];
            }
        USBDevConf->BufferRemaind = 0;
        }
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
static void f_StartReadPPI_DMA
    (
    void
    )
    {    
    AlteraDev->PPI_Running = true;
    PrepareDescrDMAAndStart( AlteraDev->PPI_rc_DMAChannel, DMA_DESCR_7, DMA_FLOW_LARGE );
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
DWORD GetNumPPIDataReady
    (
    void
    )
    {
    DWORD nData = 0;
    int a = 0;
    	
    if (   AlteraDev->NewPPIBufferEnded
        || GetOverflowStatus( AlteraDev->DataProcessPPITimer )
        || (g_device_mode == e_DeviceMode_ETH)
       )
        {
        DWORD CurrAddr;
	    DWORD CurrIndex;
	    unsigned int_latch;
	    
        ClearOverflowStatus( AlteraDev->DataProcessPPITimer );
        AlteraDev->NewPPIBufferEnded = false;
        
        int_latch = cli();
	    ssync();
        
        CurrAddr = GetDMACurrAddress( AlteraDev->PPI_rc_DMAChannel );
        CurrIndex = CurrAddr - (DWORD)PPI_Recv_Data;
        
        //if (CurrIndex != 8)
        //    nData = 0;
        
	    /*    */
	    CurrIndex >>= 1;
	    if (CurrIndex >= PPI_Recv_Data_Size_Word)
	        CurrIndex = 0;
	    AlteraDev->CurRecvBufPtr = CurrIndex;
	    //int_latch = cli();
	    //ssync();
	    if (CurrIndex >= AlteraDev->CurRecvBufPtrProcesed)
	        {
	        nData = CurrIndex - AlteraDev->CurRecvBufPtrProcesed;
	        }
        else
            {
		    nData = PPI_Recv_Data_Size_Word - AlteraDev->CurRecvBufPtrProcesed;
            }
		sti( int_latch );
		ssync();
		
		//if (nData != 4)
        //    nData = 0;
            
        a = 1;
        }
        
        
    //if (nData != 4)
    //    nData = 0;
        
    if (a && nData != 4)
        a = 2;
        
    return nData;
}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void InitiateSPORTTransfer
    (
    void
    )
    {
    PG_PINS_INTERRUPT_B_SET( AlteraDev->WRITE_PERM_FLAG_G );
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void OpenAlteraDataInterface
    (
    t_AlteraDataStruct *DefAlteraDataDev
    )
    {
    DWORD FrameFreq;
    DWORD SPORT_Freq;
    
    	
    AlteraDev = DefAlteraDataDev;      
    
    CloseAlteraDataInterface();
      
    PG_PINS_EDGE |= AlteraDev->NEW_MODULE_FLAG_G;    
    PG_PINS_PERIF_ENABLE( PG0 | PG1 | PG2 | PG3 | PG4 | PG5 | PG6 | PG7 );
    PF_PINS_PERIF_ENABLE( PPI_FS1_F | PPI_CLK_F );
    
    SPORT_Freq = CurSystClkHz >> 1;         /*     */
    FrameFreq = SPORT_Freq >> 4;            /* SPORT_Freq/16 */
    SetSPORTClkTransmit( AlteraDev->SPORT_Ch, &SPORT_Freq, &FrameFreq );
    
    /*  SPORT    Slave
     * SPORt  ,      DMA
     */
    ConfigureSPORTTransmit(AlteraDev->SPORT_Ch,
                            false,          /* bool TransmitEnable, */
    						true,           /* bool InternalClock, */
							Normal_Operation_Transmit, 
                            false,          /* bool LSBFirst, */
							true,           /* bool InternalFrames, */
							true,           /* bool FrameEveryDataWord, */
							false,          /* bool DataInDependFrame, */
							false,          /* bool ActiveLowFrame, */
							true,           /* bool LateFrameSync, */
							false,          /* bool InternFalingExternRising, */
							SLEN_16, 
							true,           /* bool SecondaryEnabled, */
							false,          /* bool StereoFrameSync, */
							false           /* bool RightStereoFirst */
							);
	/* PPI */
	ConfPPITime(0,                          /*WORD PPIDelay, */
				4,                          /* WORD PPICount, */
				0                           /* WORD PPIFrame */
				);                
				
				
	ConfigurePPI(false,                     /* bool Transmit, */
                 PPI_rcv_Non_ITU,           /* _PPI_transfer_type Tr_type, */
                 PPI_rcv_1_ext_framesync,   /* _PPI_port_cfg port_cfg, */
                 PPI_rx_ext_trigger,        /* _PPI_active_trig trig, */
                 true,                      /* bool  Pack, */
                 e_PPI_data_8,
                 true,                      /* bool ClkFallingEdge, */
                 false                      /* bool FrameFallingEdge */
                 );
                
     
	ConfigureDMAChannelReg( AlteraDev->SPORT_tr_DMAChannel, NULL, 0, 2 );
	PrepareRegDMAAndStart( AlteraDev->SPORT_tr_DMAChannel, false, DMA_WORD_16,true, DMA_DESCR_0,
        DMA_FLOW_STOP, false );
	/*    */
	SetDMACurrAddress( AlteraDev->PPI_rc_DMAChannel,
	    (DWORD)AlteraDev->READ_PPI[ 0 ].DMAXFER.Large.StartAddress );
	ConfigureDMAChannelDesc( AlteraDev->PPI_rc_DMAChannel, &AlteraDev->READ_PPI[ 0 ].DMAXFER );
              
	f_StartReadPPI_DMA();   
	                   							        
    AlteraDev->Opened = true;           
    
    /*     DMA */
    Set_Enable_InterruptIVG_Perif( PortG_B_Interrupt, AlteraDev->SPORT_IVG,
        NULL/*AlteraInterfaceSPORTInterrupt*/ );
    /*     DMA */
    Set_Enable_InterruptIVG_Perif( DMA4_SPORT0_TX_Interrupt, AlteraDev->SPORT_IVG,
        NULL/*AlteraInterfaceSPORTInterrupt*/ );
    /*     DMA */
    Set_Enable_InterruptIVG_Perif( DMA0_PPI_Interrupt, AlteraDev->PPI_IVG, NULL/*PPIDMAComplitedHandler*/ );
    
    PG_PINS_INTERRUPT_B_SET( AlteraDev->WRITE_PERM_FLAG_G | AlteraDev->NEW_MODULE_FLAG_G );
    
    ConfiGureTimerPeriodAndWidth( AlteraDev->DataProcessPPITimer, (CurSystClkHz / 1000) * 5, 0 );
    EnableTimers( AlteraDev->DataProcessPPITimer );
    EnablePPI;
    Set_SPORT_Finish_Transmit( AlteraDev->SPORT_Ch );
    
    /* SPORT   */
    AlteraDev->SPORT_Enabled = false;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
//EX_INTERRUPT_HANDLER( PPIDMAComplitedHandler )
void vIVG11_handle(void)
    {
    /*    */
    *pDMA0_IRQ_STATUS = DMA_DONE;
    if (++AlteraDev->CurRecvBufDMA >= PPI_DMA_ARRAY_SIZE)
        AlteraDev->CurRecvBufDMA = 0;
    AlteraDev->NewPPIBufferEnded = true;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void ResetSPORT
    (
    void
    )
    {      
    /* DMA       - anomaly    
     *   DMA
     */
    StopDMA( DMA_DMA4 );
    DisableSPORTTransmit( AlteraDev->SPORT_Ch );
    ResetSPORTTransmit( AlteraDev->SPORT_Ch );
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void SetDefaultAlteraConfiguration
    (
    t_AlteraDataStruct *DefAlteraDataDev
    )
    {
    WORD i;
    	
    memset( DefAlteraDataDev, 0, sizeof(t_AlteraDataStruct) );
    DefAlteraDataDev->WRITE_PERM_FLAG_G = ALTERA_POS_WRITE_G;
    DefAlteraDataDev->NEW_MODULE_FLAG_G = ALTERA_MODULE_CHANGE;
    
    DefAlteraDataDev->NewModulesAppearence = false;
    
    DefAlteraDataDev->SPORT_Ch = SPORT0_CHANNEL;
    
    DefAlteraDataDev->PPI_rc_DMAChannel = DMA_DMA0;
    DefAlteraDataDev->SPORT_tr_DMAChannel = DMA_DMA4;   
    
    DefAlteraDataDev->DataProcessPPITimer = TIMER7;

    DefAlteraDataDev->SPORT_IVG = IVG10;
    DefAlteraDataDev->PPI_IVG = IVG11;       
    DefAlteraDataDev->AlteraSPORTReady = true;
    DefAlteraDataDev->PPI_Running = false;
    DefAlteraDataDev->SPORT_Running = false;
    
    DefAlteraDataDev->OverflowBuffersEvent = false;/* !!! */
    
    for (i = 0; (i < PPI_DMA_ARRAY_SIZE); i++)
        {
        if (i < PPI_DMA_ARRAY_SIZE - 1)     
            {
	    	DefAlteraDataDev->READ_PPI[ i ].DMAXFER.Large.pNext =
	    	    (void *)&DefAlteraDataDev->READ_PPI[ i+1 ].DMAXFER.Large;
            }
        else
            {
            DefAlteraDataDev->READ_PPI[ i ].DMAXFER.Large.pNext =
                (void *)&DefAlteraDataDev->READ_PPI[ 0 ].DMAXFER.Large;
            }
        
		DefAlteraDataDev->READ_PPI[ i ].DMAXFER.Large.StartAddress =
		    (void *)&PPI_Recv_Data[ i*DMA_MAX_TRANSFER_COUNT ];
		DefAlteraDataDev->READ_PPI[ i ].DMAXFER.Large.Config.VALUE =
		    PrepareDMAConfig( true, DMA_WORD_16, true, DMA_DESCR_7, DMA_FLOW_LARGE, false );
		DefAlteraDataDev->READ_PPI[ i ].DMAXFER.Large.XCount = 0; /* 65536 */
		DefAlteraDataDev->READ_PPI[ i ].DMAXFER.Large.XModify = 2;
        }
    
    DefAlteraDataDev->WRITE_SPORT.DataPointer = SPORT_Tran_Data;
    DefAlteraDataDev->CurRecvBufDMA = 0;
    DefAlteraDataDev->CurRecvBufPtr = 0;
    DefAlteraDataDev->CurRecvBufPtrProcesed = 0;
    DefAlteraDataDev->CurSndBufferPtr = 0;
    DefAlteraDataDev->CurSndBufferPtrProcessed = 0;
    DefAlteraDataDev->LastSndSize = 0;
    DefAlteraDataDev->SndBufAvail = SPORT_Transmit_Data_Size_Word * 2;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void StartWriteSPORT_DMA
    (
    WORD *Data,
    DWORD NumData
    )
    {
    /*      ,    ,     128 DWORD 
     * 
     */
    while (!AlteraSPORTReady())
        {
        continue;
        }
    
    AlteraDev->WRITE_SPORT.DataCounter = NumData;
    AlteraDev->WRITE_SPORT.DataPointer = Data;  	
    
    InitiateSPORTTransfer();
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
