#ifndef ALTERADATAINTERFACE_H_
#define ALTERADATAINTERFACE_H_

/*================================================================================================*/
/*    1024*32 */
#define PPI_DMA_ARRAY_SIZE (64)
#define SPORT_DMA_ARRAY_SIZE (31)//(62)
#define PPI_Recv_Data_Size_Word	(DMA_MAX_TRANSFER_COUNT * PPI_DMA_ARRAY_SIZE)
#define SPORT_Transmit_Data_Size_Word (DMA_MAX_TRANSFER_COUNT*SPORT_DMA_ARRAY_SIZE)
#define MaxSPORT_DMA_Size_WORD (256)
/*================================================================================================*/

/*================================================================================================*/
typedef struct
    {
    DMA_DESCRIPTOR_UNION DMAXFER;
    bool BufferTransmitted;
    bool BufferRecieved;
    } t_AlteraDMAPPIStruct;
typedef struct
    {
    /* DMA_DESCRIPTOR_UNION DMAXFER; */
    WORD *DataPointer;
    DWORD DataCounter;    
    } t_AlteraDMASPORTStruct;
#pragma pack(4)
typedef struct
    {
    WORD WRITE_PERM_FLAG_G;
    WORD NEW_MODULE_FLAG_G;
    SPORT_CHANNEL SPORT_Ch;
    DMA_CHANNEL_ID PPI_rc_DMAChannel;
	DMA_CHANNEL_ID SPORT_tr_DMAChannel;
	INTERRUPT_IVG SPORT_IVG;
	INTERRUPT_IVG PPI_IVG;	
	t_TIMERS DataProcessPPITimer;	
	t_AlteraDMAPPIStruct READ_PPI[PPI_DMA_ARRAY_SIZE];
    t_AlteraDMASPORTStruct WRITE_SPORT;  	
    DWORD CurRecvBufDMA;
    DWORD CurRecvBufPtr;
    DWORD CurRecvBufPtrProcesed;
    DWORD CurSndBufferPtr;
    DWORD CurSndBufferPtrProcessed;
    DWORD LastSndSize;
    unsigned long SndBufAvail;
    bool Opened;
    bool SPORT_Running;
    bool SPORT_Enabled;	                    /* SPORT  */
    bool PPI_Running;
    bool AlteraSPORTReady;
    bool NewModulesAppearence;
    /*   true     */
    bool OverflowBuffersEvent;
    bool NewPPIBufferEnded;
    } t_AlteraDataStruct;
#pragma pack()
/*================================================================================================*/


/*================================================================================================*/
EX_INTERRUPT_HANDLER( AlteraInterfaceSPORTInterrupt );
bool AlteraSPORTReady(void);
void CloseAlteraDataInterface(void);
void CommitDataFromPPIBuffer(DWORD NumDataWord);
void CommitDataFromSPORTBuffer(DWORD NumDataWord);
DWORD GetNumPPIDataReady(void);
void InitiateSPORTTransfer(void);
void OpenAlteraDataInterface(t_AlteraDataStruct *DefAlteraDataDev);
EX_INTERRUPT_HANDLER( PPIDMAComplitedHandler );
void ResetSPORT(void);
void SetDefaultAlteraConfiguration(t_AlteraDataStruct *DefAlteraDataDev);
void StartWriteSPORT_DMA(WORD * Data, DWORD NumData);
/*================================================================================================*/

/*================================================================================================*/
extern t_AlteraDataStruct *AlteraDev;
extern WORD PPI_Recv_Data[ PPI_Recv_Data_Size_Word ];
extern WORD SPORT_Tran_Data[ SPORT_Transmit_Data_Size_Word ];//+512];	//
/*================================================================================================*/

#endif /*#ifndef ALTERADATAINTERFACE_H_*/
