#include "hardware.h"


/*================================================================================================*/
HandlerType ContinuePeripheralErrorInterrupt = NULL;
t_ETHERNET_BF537_CONF *EtherDevice;

segment ("sdram0_bank1") DWORD EthernetBuffer[ EthernetBufferSizeDWORD ];
BYTE *EtherData = (BYTE *)EthernetBuffer;

segment ("sdram0_bank1") t_READ_BUFFER_INFO MAC_READ_DESCR[ NumFrameRecv ];
segment ("sdram0_bank1") t_WRITE_BUFFER_INFO MAC_WRITE_DESCR[ NumFrameTran ];
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void SetupDMA
	(
	void
	)
	{
	WORD i;
	WORD NextDescr;
	DWORD RecieveSize;

	memset( MAC_READ_DESCR, 0, sizeof(MAC_READ_DESCR) );
	memset( MAC_WRITE_DESCR, 0, sizeof(MAC_WRITE_DESCR) );

	for (i = 0; (i < NumFrameRecv); i++)
		{
		NextDescr = (i + 1) % NumFrameRecv;
		MAC_READ_DESCR[ i ].DataDescr.pNext = &MAC_READ_DESCR[ i ].StatusDescr;
		MAC_READ_DESCR[ i ].DataDescr.StartAddress = &EtherData[ i*FrameRecvSize ];
		MAC_READ_DESCR[ i ].DataDescr.Config.VALUE = PrepareDMAConfig( true, DMA_WORD_32, false,
			DMA_DESCR_5, DMA_FLOW_LARGE, false );
		MAC_READ_DESCR[ i ].DataDescr.XCount = 0;

		MAC_READ_DESCR[ i ].StatusDescr.pNext = &MAC_READ_DESCR[ NextDescr ].DataDescr;
		MAC_READ_DESCR[ i ].StatusDescr.StartAddress = &MAC_READ_DESCR[ i ].Status;
		MAC_READ_DESCR[ i ].StatusDescr.Config.VALUE = PrepareDMAConfig( true, DMA_WORD_32, true,
			DMA_DESCR_5, DMA_FLOW_LARGE, false );
		MAC_READ_DESCR[ i ].StatusDescr.XCount = 0;
		}

	RecieveSize = FrameRecvSize * NumFrameRecv;
	for (i = 0; (i < NumFrameTran); i++)
		{
		NextDescr = (i + 1) % NumFrameRecv;

		MAC_WRITE_DESCR[ i ].LengthDescr.pNext = &MAC_WRITE_DESCR[ i ].DataDescr;
		MAC_WRITE_DESCR[ i ].LengthDescr.StartAddress = &MAC_WRITE_DESCR[ i ].Length;
		MAC_WRITE_DESCR[ i ].LengthDescr.Config.VALUE = PrepareDMAConfig( false, DMA_WORD_32, false,
			DMA_DESCR_5, DMA_FLOW_LARGE, false );
		MAC_WRITE_DESCR[ i ].LengthDescr.XCount = 4;

		MAC_WRITE_DESCR[ i ].DataDescr.pNext = &MAC_WRITE_DESCR[ i ].StatusDescr;
		MAC_WRITE_DESCR[ i ].DataDescr.StartAddress = &EtherData[ RecieveSize + i*FrameTransSize ];
		MAC_WRITE_DESCR[ i ].DataDescr.Config.VALUE = PrepareDMAConfig( false, DMA_WORD_32, false,
			DMA_DESCR_5, DMA_FLOW_LARGE, false );
		MAC_WRITE_DESCR[ i ].DataDescr.XCount = 0;

		MAC_WRITE_DESCR[ i ].StatusDescr.pNext = &MAC_WRITE_DESCR[ NextDescr ].LengthDescr;
		MAC_WRITE_DESCR[ i ].StatusDescr.StartAddress = &MAC_WRITE_DESCR[ i ].Status;
		MAC_WRITE_DESCR[ i ].StatusDescr.Config.VALUE = PrepareDMAConfig( false, DMA_WORD_32, true,
			DMA_DESCR_0, DMA_FLOW_STOP, false );
		MAC_WRITE_DESCR[ i ].StatusDescr.XCount = 0;
		}

	ConfigureDMAChannelPerif( DMA_DMA1, DMA_PMAP_MAC_RX );
	ConfigureDMAChannelPerif( DMA_DMA2, DMA_PMAP_MAC_TX );

	/* initialize the TX DMA channel registers */
	*pDMA2_X_COUNT = 0;
	*pDMA2_X_MODIFY = 4;

	/* initialize the RX DMA channel registers */
	*pDMA1_X_COUNT = 0;
	*pDMA1_X_MODIFY = 4; 

	ConfigureDMAChannelDesc( DMA_DMA1, (DMA_DESCRIPTOR_UNION *)&MAC_READ_DESCR[ 0 ].DataDescr );
	ConfigureDMAChannelDesc( DMA_DMA2, (DMA_DESCRIPTOR_UNION *)&MAC_WRITE_DESCR[ 0 ].LengthDescr );

	PrepareDescrDMAAndStart( DMA_DMA1, DMA_DESCR_5, DMA_FLOW_LARGE );

	Enable_Interrupt_Perif( DMA1_MAC_RX_PHA_Interrupt );
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void SetDefaultEthernetParameters
	(
	t_ETHERNET_BF537_CONF *dev
	)
	{
	char hwaddr[ 6 ] = {0x00, 0xE0, 0x22, 0xFE, 0x4F, 0x1D};
	    
	memset( dev, 0, sizeof(t_ETHERNET_BF537_CONF) );
	dev->RXIVG = IVG7;
	dev->TXIVG = IVG8;
	dev->EtherIntIVG = IVG13;      
	dev->CurTXFrame = 0;
	dev->CurRXFrame = 0;
	dev->PhyAddr = 1;                          /*    */
	dev->Port10 = false;
	dev->EnableAutoMDIX = true;
	dev->FullDuplex = false;
	dev->Negotiate = true;
	dev->StripPads = true;                     /*     */
	dev->MDC_Freq = 2500000;                   /* 2.5Mhz PHY MDC Freq */
	
	memcpy( dev->Mac, hwaddr, sizeof hwaddr );     
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
bool StartMAC
	(
	t_ETHERNET_BF537_CONF *dev
	)
	{
	WORD Div;
	float Divf;
	int InterruptLatch = disable_interrupt;
	WORD TempData;

	/*  MAC */
	*pEMAC_OPMODE = 0;

	EtherDevice = dev;
	PH_PINS_PERIF_ENABLE( PH0|PH1|PH2|PH3|PH4|PH5|PH6|PH7|PH8|PH9|PH10|PH11|PH12|PH13|PH14|PH15 );

	/*  PHY   CLKBuff */
	EnableClkBufOut();

	SetMacAddr( dev->Mac );

	SetupDMA();

	/*     DMA */
	Set_Enable_InterruptIVG_Perif( DMA1_MAC_RX_PHA_Interrupt, dev->RXIVG,
		DMA_MAC_RX_InterruptHandler );
	/*     DMA */
	Set_InterruptIVG_Perif( DMA2_MAC_TX_PHB_Interrupt, dev->TXIVG, DMA_MAC_TX_InterruptHandler );
	/*     DMA */
	Set_Enable_InterruptIVG_Perif( Peripheral_Error_Interrupt, dev->EtherIntIVG,
		PeripheralErrorInterruptHandler );

	/*   MMC,  ,     */
	*pEMAC_MMC_CTL = MMCE | CCOR | RSTC;
	TempData = 0;
	if (dev->StripPads)
		TempData |= ASTP;
	*pEMAC_OPMODE = TempData;

	/* dont enable RX and TX until we have a buffer to start the DMA with */
	TempData = 0;
	if (dev->GenChksums)
		TempData |= RXCKS;
	if (!dev->RxWordAligment)
		TempData |= RXDWA;	
	//if(!dev->TxWordAligment)TempData|=TXDWA;   -   3  	

	Divf = (CurSystClkHz / dev->MDC_Freq) / 2 - 1;
	Div = (WORD)Divf;
	if (Divf - (float)Div > 0.5f)
		Div++;	

	/* or in the SCLK:MDC divisor */
	TempData = (Div << 8) | TempData;
	*pEMAC_SYSCTL = TempData;
	/*  ,     PHY */
	SetPhy( dev );
	if (   ((dev->PhyID & 0xFFFF) != 0x0007)
	    || (((dev->PhyID & 0xFFF00000) != 0xC0A00000) && ((dev->PhyID & 0xFFF00000) != 0xC0C00000))
	   )
		{
	    /*   93185   LAN8700 */
		return false;
		}

	/*   PHY */
	WrPHYReg( dev->PhyAddr, PHYREG_INT_SOURMASK, PHY_INT_ENERGYON|PHY_INT_Link_Down|
		PHY_INT_Remote_Fall|PHY_INT_Par_Det_Fall|PHY_INT_AN_Complete );
	/*    */		
	RdPHYReg( dev->PhyAddr, PHYREG_INT_SOURMASK );
	/* now actually enable the interrupts */
	*pEMAC_MMC_RIRQE = 0x00FFFFFF;             /* RX counter interrupts */
	*pEMAC_MMC_TIRQE = 0x00FFFFFF;             /* RX counter interrupts */

	/*     */
	*pEMAC_OPMODE |= RE | TE;

	dev->Started = true;

	/*      */
	InterruptLatch |= disable_interrupt;
	enable_interrupt( InterruptLatch );
	return true;
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void StopMAC
	(
	t_ETHERNET_BF537_CONF *dev
	)
	{
	Disable_Interrupt_Perif( DMA1_MAC_RX_PHA_Interrupt );
	Disable_Interrupt_Perif( DMA2_MAC_TX_PHB_Interrupt );      

	/* DMA       - anomaly    
	 *   DMA
	 */
	StopDMA( DMA_DMA1 );
	StopDMA( DMA_DMA2 ); 

	*pEMAC_OPMODE = 0;
	ssync();
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void ReadEthernetDevice
	(
	BYTE *pData,
	DWORD NumData
	)
	{
	return;
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void WriteEthernetDevice
	(
	BYTE *pData,
	DWORD NumData
	)
	{
	t_ETHERNET_BF537_CONF *dev = EtherDevice;
	
	while (NumData)
		{
		WORD NumWrite = min( FrameTransSize, NumData );
		memcpy( MAC_WRITE_DESCR[ dev->CurTXFrame ].DataDescr.StartAddress, pData, NumWrite );
		*(DWORD *)MAC_WRITE_DESCR[ dev->CurTXFrame ].LengthDescr.StartAddress = NumData;
		if (++dev->CurTXFrame >= NumFrameTran)
			dev->CurTXFrame = 0;
		}
	Enable_Interrupt_Perif( DMA2_MAC_TX_PHB_Interrupt );
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
EX_INTERRUPT_HANDLER( DMA_MAC_RX_InterruptHandler )
	{
	/* confirm the DMA interrupt */
	t_ETHERNET_BF537_CONF *dev;
	WORD i;
	WORD NumFramesRecv;
	
	*pDMA1_IRQ_STATUS = DMA_DONE;
	dev = EtherDevice;
	NumFramesRecv = *pEMAC_RXC_OK;		
	
	for (i = dev->NumFramesRecv; (i < dev->NumFramesRecv + NumFramesRecv); i++)
		{
		WORD ff = MAC_READ_DESCR[ i ].Status.StatusWord;
		if (MAC_READ_DESCR[ i ].Status.StatusWord & RX_OK)
			{
			dev->NumBytesRecv += MAC_READ_DESCR[ i ].Status.StatusWord & 0x07FF;
			MAC_READ_DESCR[ i ].DataReady = true;
			}
		}
	dev->NumFramesRecv += NumFramesRecv;
	if (dev->NumFramesRecv >= NumFrameRecv)
		dev->NumFramesRecv -= NumFrameRecv;
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
EX_INTERRUPT_HANDLER( DMA_MAC_TX_InterruptHandler )
	{
	/* confirm the DMA interrupt */
	*pDMA2_IRQ_STATUS = DMA_DONE;
	t_ETHERNET_BF537_CONF *dev = EtherDevice;

	if ((*pDMA2_IRQ_STATUS & (DMA_DONE | DMA_RUN | DFETCH)) == DMA_DONE)    	
		{
		/*   DMA ,   */
		dev->NumFramesTran += *pEMAC_TXC_OK;
		if (dev->NumFramesTran >= NumFrameTran)
			dev->NumFramesTran -= NumFrameTran;
		if (dev->NumFramesTran != dev->CurTXFrame)
			{
			/*      */
			PrepareDescrDMAAndStart( DMA_DMA2, DMA_DESCR_5, DMA_FLOW_LARGE );
			}
		}
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
EX_INTERRUPT_HANDLER( PeripheralErrorInterruptHandler )
	{
	t_ETHERNET_BF537_CONF * dev = EtherDevice;
	WORD systat = *pEMAC_SYSTAT;
	
	/*  sticky bit */
	*pEMAC_SYSTAT = 0xE1;
	if (systat & MMCINT)
		{
		/* MMC counter interrupt */
		DWORD rirqs = *pEMAC_MMC_RIRQS;
		DWORD tirqs = *pEMAC_MMC_TIRQS;

		/* clear the interrupt */
		*pEMAC_MMC_RIRQS = rirqs;
		*pEMAC_MMC_TIRQS = tirqs;		
		}
	if (systat & PHYINT)
		{
		WORD PhyInt;
		    
		systat &= ~PHYINT;
		PhyInt = RdPHYReg( dev->PhyAddr, PHYREG_INT_SOURCE );
		if (PhyInt & (PHY_INT_ENERGYON | PHY_INT_Link_Down))
			{
            /*   ,   PHY  ,  does remote link
             * support flow control
             */
            if (RdPHYReg( dev->PhyAddr, PHYREG_ANLPAR ) & (1 << 10)) 
				{
                /* we enable flow control */
				dev->FlowControl = true;
				*pEMAC_FLC = FLCE;		
				} 
			else
				{
				dev->FlowControl = false;
				*pEMAC_FLC &= ~FLCE;		
				}			
			}

		if (PhyInt & (PHY_INT_Remote_Fall | PHY_INT_Par_Det_Fall))
			{
			/*   */
            ;
			}

		if (PhyInt & PHY_INT_AN_Complete)
			{
            /*  autonegotiation */
			ProcessNegotiationResult( dev );
			}
		}

	if (systat & MMCINT)
    	systat &= ~MMCINT;

	if (ContinuePeripheralErrorInterrupt != NULL)
	    ContinuePeripheralErrorInterrupt();   
	}
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
