#ifndef ETHER_H_
#define ETHER_H_


/*================================================================================================*/
#pragma pack(4)
typedef struct 
    {
    WORD IPHdrChksum;                       /* the IP header checksum */
    WORD IPPayloadChksum;                   /* the IP header and payload checksum */
    DWORD StatusWord;                       /* the frame status worrd */
    } t_STATUS_AREA;
typedef struct 
    {
    /* this structure is overlaid on the start of the ADI_ETHER_BUFFER structure on the area
     * reserved for the physical dev. driver
     */
    DMA_DESCRIPTOR_TINY DataDescr;          /* first descriptor associated with buffer */
    DMA_DESCRIPTOR_TINY StatusDescr;        /* last descriptor associated with buffer */
    t_STATUS_AREA Status;                   /* address of the status word area */
    bool DataReady;
    } t_READ_BUFFER_INFO;
typedef struct 
    {
    /* this structure is overlaid on the start of the ADI_ETHER_BUFFER structure on the area
     * reserved for the physical dev. driver
     */
    DMA_DESCRIPTOR_TINY LengthDescr;        /* first descriptor associated with buffer */
    DMA_DESCRIPTOR_TINY DataDescr;          /* first descriptor associated with buffer */
    DMA_DESCRIPTOR_TINY StatusDescr;        /* last descriptor associated with buffer */
    t_STATUS_AREA Status;                   /* address of the status word area */
    BYTE Length[ 16 ];                      /* Header for Transmit */
    bool DataReady;
    } t_WRITE_BUFFER_INFO;
#pragma pack()

#define NumFrameRecv 1024
#define NumFrameTran 1024
/*         */
#define FrameRecvSize 1556 
#define FrameTransSize 1560

#define EthernetBufferSize 		((NumFrameRecv*FrameRecvSize)+(NumFrameTran*FrameTransSize))
#define EthernetBufferSizeDWORD	(EthernetBufferSize/4)
#define EthernetDescrSizeDWORD	((NumFrameRecv+NumFrameTransmit)*)
/*================================================================================================*/

/*================================================================================================*/
extern HandlerType ContinuePeripheralErrorInterrupt; 
extern t_ETHERNET_BF537_CONF *EtherDevice;
extern DWORD EthernetBuffer[ EthernetBufferSizeDWORD ];
/*================================================================================================*/

/*================================================================================================*/
EX_INTERRUPT_HANDLER( DMA_MAC_RX_InterruptHandler );
EX_INTERRUPT_HANDLER( DMA_MAC_TX_InterruptHandler );
EX_INTERRUPT_HANDLER( PeripheralErrorInterruptHandler );
void SetDefaultEthernetParameters(t_ETHERNET_BF537_CONF * dev);
bool StartMAC(t_ETHERNET_BF537_CONF * dev);
void StopMAC(t_ETHERNET_BF537_CONF * dev);
/*================================================================================================*/

#endif /*#ifndef ETHER_H_*/
