#ifndef ISP_H_
#define ISP_H_
 

/*================================================================================================*/
/*    WORD */
//#define MaxDMATransferSize 256

/*     Bulk - 512,  - 8 */
#define BULK_RXBUFLEN_SIZE (512 / 8)

/* endpoit state */
#define EP0_PACKET_SIZE (64)
#define EP_IDLE (0)
#define EP_WAIT_RX (1)
#define EP_WAIT_TX (2)
#define EP_WAIT_ACK (3)
#define EP_HALTED (7)

/*     DMAR,        
 *    
 */
#define DMAR_ARRAY_SIZE	(64)
//#define MAX_DMAR_TransferSize (DMA_MAX_TRANSFER_COUNT * DMAR_ARRAY_SIZE)

/* define    */
#define USBDevConf_PORTF_INT                ISP1583_INT_F
#define USBDevConf_PORTF_DREQ               ISP1583_DREQ_F
#define USBDevConf_PORTF_DREQ_DMAR          ISP1583_DREQ_DMAR_F
#define USBDevConf_PORTG_READY_WRITE_EDGE   ISP1583_READY_G
#define USBDevConf_PORTG_READY_WRITE_LEV    ISP1583_READY2_G
		
#define USBDevConf_HDMA_Channel        HDMA_CHANNEL0
#define USBDevConf_MEMDMA_Source       DMA_MDMA_S0
#define USBDevConf_MEMDMA_Dest         DMA_MDMA_D0


#define SET_ISP1583_RES() do {PG_PINS_CLR( ISP1583_RESET_G );}while(0);
#define CLR_ISP1583_RES() do {PG_PINS_SET( ISP1583_RESET_G );}while(0);
/*================================================================================================*/

/*================================================================================================*/
typedef struct
    {
    BYTE state;
    BYTE sel;
    WORD cntr; 
    DWORD ptr;  
    } ENDPOINT_CONTROL;
typedef struct
    {
    BYTE state;
    } ENDPOINT_INTERRUPT;
typedef struct
    {
    BYTE state;
    BYTE sel;
    DWORD cntr;
    DWORD ptr;
    } ENDPOINT_BULK;
typedef struct
    {	
    WORD *ptr;
    DWORD cntr;	
    } ENDPOINT_DMA;

#pragma pack(1)
typedef struct 
    {
    BYTE bmRequestType;
    BYTE bRequest;
    WORD wValue;
    WORD wIndex;
    WORD wLength;
    } USB_DEVICE_REQ;
#pragma pack()

#pragma pack(4)
typedef struct
    {
	bool Opened;
	bool DMAReady;
	WORD USB_FLAGS;	
	WORD DataReadyToSPORT;	
	DWORD DataTransmittedFromPPI;
	INTERRUPT_IVG USBIVG;		
	/*	
	WORD PORTF_INT;
	WORD PORTF_DREQ;
	WORD PORTF_DREQ_DMAR;
	WORD PORTG_READY_WRITE;
	
	HDMA_CHANNEL_ID    HDMA_Channel;
	
	DMA_CHANNEL_ID     MEMDMA_Source;
	DMA_CHANNEL_ID     MEMDMA_Dest;
	*/
	DMA_DESCRIPTOR_UNION WriteISPLargeData[ DMAR_ARRAY_SIZE ];
	DMA_DESCRIPTOR_UNION MEMDSP_RW;
    DMA_DESCRIPTOR_UNION ISP_RW;  
    
    WORD MaxBulkSize;
    
    /*     ISP Bulk Rx */
    WORD BufferLengthBulkRx[ BULK_RXBUFLEN_SIZE ];
    int BufferLengthBulkRxIndex;
    int BufferLengthBulkRxIndexProc;
    
    WORD BufferRemaind;	                    /*    */
    
     
	ENDPOINT_CONTROL ep0;
	ENDPOINT_INTERRUPT ep1;
	ENDPOINT_BULK ep2rx;
	ENDPOINT_BULK ep2tx;
	
	int ep2rxEn;
	int ep2rxAbort;
	
	ENDPOINT_DMA epDMA;
	
	USB_DEVICE_REQ dreq;
	bool ChangeSystemRegisters;
    int WriteDMAISPFlag;                    /*     */
    } t_USB_DevConfStruct;
#pragma pack()
/*================================================================================================*/

/*================================================================================================*/
extern t_USB_DevConfStruct *USBDevConf;
/*================================================================================================*/

/*================================================================================================*/
void ACKNOWLEDGE(WORD ep);
void CloseISP1583(void);
void ConfigUSB(BYTE usb_state);
WORD GetEPBulkDataRecieved(void);
bool ISP_DMA_Running(void);
void OpenISP1583(t_USB_DevConfStruct *USBDevConfThis);
void SetDefaultUSBParameters(t_USB_DevConfStruct *USBDevConfThis);
void STALL(WORD ep);
void start_readDMA_ISP(WORD *Data, DWORD NumData);
void start_writeDMA_ISP(WORD *Data, DWORD NumData);
void start_writeDMA_ISP_DMAR(WORD *Data, DWORD NumData);
void UNSTALL(WORD ep);
EX_INTERRUPT_HANDLER(USB_InterruptHandler);
/*================================================================================================*/

#endif /*#ifndef ISP_H_*/
