//***********************************************************************
//                                                                                           *
//                P H I L I P S   P R O P R I E T A R Y                     *
//                                                                      *
//          COPYRIGHT (c)   1999 BY PHILIPS SINGAPORE (APIC).               *
//                    --  ALL RIGHTS RESERVED  --                         *    
//                                                                      *
//     File Name    :       D14.h                                            *
//     Author        :       Albert Goh                                               *
//     Created        :          3 March 2000                                   *
//                                                                         *
//***********************************************************************
//***********************************************************************
//                                                                      *
// Kernel.h has the various external defintion and structure defintion  *
//                                                                      *
//***********************************************************************
//***********************************************************************
//                                                                      *
//  Module History                                                                    *
//  **************                                                                    *
//                                                                                          *
//  Date       Version            Author                Changes                          *
//  ====       =======            ======                =======                          *
//  030300      0.1             Albert                Created                          *
//                                                                      *
//                                                                      *
//***********************************************************************
//***********************************************************************
//*                                                                                       *
//*                     Structure Variable Definition                            *
//*                                                                                       *
//***********************************************************************
//***********************************************************************
//*                                                                                        *
//*                   D14 Structure Definition                                  *
//*                                                                                       *
//***********************************************************************
#ifndef __ISR_REG_H__
#define __ISR_REG_H__

#define    GDMA_Read_Command        0x00
#define    GDMA_Write_Command        0x01
#define    UDMA_Read_Command        0x02
#define    UDMA_Write_Command        0x03
#define    PIO_Read_Command        0x04
#define    PIO_Write_Command        0x05
#define    MDMA_Read_Command        0x06
#define    MDMA_Write_Command        0x07
#define    PIO_Write_Complete        0x08
#define    PIO_Read_Complete         0x09
#define    READ_1F0                0x0A
#define    POLL_BUSY                0x0B
#define    UPDATE_TASKFILE            0x0C

#define  DMA_VALIDATE_BUFFER        0x0E
#define  DMA_CLEAR_BUFFER           0x0F
#define  DMA_BUFFER_RESTART         0x10
#define  DMA_RESET                  0x11
#define  DMA_FLUSH                  0x12
#define  GDMA_STOP                  0x13

typedef union 
{
    struct ADDRESS_BITS
    {
        BYTE    DEVADDR     :7;
        BYTE    DEVEN       :1;
        BYTE    UNUSED;
    }BITS;

    WORD    VALUE;
}_ADDRESS_REG;


typedef union 
{
    struct USB_MODE_BITS
    {
        BYTE    SOFTCT      :1;
        BYTE    PWRON       :1;
        BYTE    WKUPCS      :1;
        BYTE    GLINTENA    :1;
        BYTE    SFRESET     :1;
        BYTE    GOSUSP      :1;
        BYTE    SNDRSU      :1;
        BYTE    CLKAON      :1;

        BYTE VBUS_STATUS    :1;
        BYTE DMACLKON       :1;
        BYTE RESERVED       :3;
        BYTE BUS_CONFIG     :1;
        BYTE MODE0          :1;
        BYTE MODE1          :1;

    }BITS;

    WORD    VALUE;

}_USB_MODE;

typedef union 
{
    struct INT_CONFIG_BITS
    {

        BYTE    INTPOL        :1;
        BYTE    INTLVL        :1;
        BYTE    DDBGMODOUT    :2;
        BYTE    DDBGMODIN     :2;
        BYTE    CDBGMOD       :2;
        BYTE    Unused;

    }BITS;

    WORD    VALUE;

}_INT_CONFIG;


typedef union 
{

    struct OTG_MODE_BITS
    {

        BYTE    OTG            :1;
        BYTE    VP                    :    1;
        BYTE    DISCV                :    1;
        BYTE    INIT                :    1;
        BYTE    BSESSVALID        :    1;
        BYTE    DP                :    1;
        BYTE    Unused;
    }BITS;

    WORD    VALUE;

}_OTG_MODE;


typedef union 
{

    struct INT_ENABLE_BITS
    {

        BYTE    IERST           :     1;
        BYTE    IESOF           :    1;
        BYTE    IEPSOF        :    1;
        BYTE    IESUSP        :    1;
        BYTE    IERESM        :    1;
        BYTE    IEHS_STA       :    1;
        BYTE    IEDMA           :    1;
        BYTE    IEVBUS       :    1;

        BYTE    IEP0SETUP    :    1;
        BYTE    RESERVED2    :     1;
        BYTE    IEP0RX        :    1;
        BYTE    IEP0TX        :    1;    
        BYTE    IEP1RX        :    1;
        BYTE    IEP1TX        :    1;    
        BYTE    IEP2RX        :    1;
        BYTE    IEP2TX        :    1;    

        BYTE    IEP3RX        :    1;
        BYTE    IEP3TX        :    1;
        BYTE    IEP4RX        :    1;
        BYTE    IEP4TX        :    1;    
        BYTE    IEP5RX        :    1;
        BYTE    IEP5TX        :    1;    
        BYTE    IEP6RX        :    1;
        BYTE    IEP6TX        :    1;    

        BYTE    IEP7RX        :    1;
        BYTE    IEP7TX        :    1;
        BYTE    RESERVED1    :    6;

    }BITS;
    
    struct
    {
        WORD LSW;
        WORD MSW;
    };
    

    DWORD    VALUE;

}_INT_ENABLE;



typedef union 
{
    struct CONTROL_BITS
    {
        BYTE  STALL:1;
        BYTE  STATUS1:1;
        BYTE  DSEN:1;
        BYTE  VENDP:1;
        BYTE  CLBUF:1;
        BYTE  RESERVED1:3;
        BYTE  Unused;

    }BITS;

    WORD    VALUE;

}_CONTROL;



typedef union 
{
    struct ENDPT_MAXSIZE_BITS
    {

        BYTE    FFOSZ7_0       :    8;
        BYTE    FFOSZ10_8    :    3;
        BYTE    NTRANS        :    2;
        BYTE    RESERVED2    :    3;

    }BITS;

    WORD    VALUE;

}_ENDPT_MAXSIZE;

typedef union 
{
    struct ENDPT_TYPE_BITS
    {

        BYTE    ENDPTYP        :    2;
        BYTE    DBLBUF        :     1;
        BYTE    ENABLE        :    1;
        BYTE    NOEMPKT        :    1;
        BYTE    RESERVED1    :    3;
        BYTE    RESRVED2       :    8;

    }BITS;

    WORD    VALUE;

}_ENDPT_TYPE;


typedef union 
{
    struct DMA_CONFIG_BITS
    {

        BYTE    WIDTH               :     1;
        BYTE    DREQ_MODE           :    1;
        BYTE    MODE                :    2;
        BYTE    RES1                   :    3;
        BYTE    DIS_XFER_CNT    :    1;

        BYTE    PIO_MODE           :    3;
        BYTE    DMA_MODE        :    2;
        BYTE    ATA_MODE           :    1;
        BYTE    IGNORE_IORDY    :    1;
        BYTE    STREAMING           :    1;

    }BITS;

    WORD    VALUE;

}_DMA_CONFIG;

typedef union 
{
    struct DMA_HARDWARE_BITS
    {

        BYTE    READ_POL       :    1;
        BYTE    WRITE_POL    :    1;
        BYTE    DREQ_POL       :    1;
        BYTE    ACK_POL        :    1;
        BYTE    MASTER        :    1;
        BYTE    EOT_POL        :    1;
        BYTE    ENDIAN        :    2;
        BYTE    Unused;
    }BITS;

    WORD    VALUE;

}_DMA_HARDWARE;


typedef union 
{
    struct DMA_STROBE_BITS
    {
        BYTE    DMA_STROBE    :    5;
        BYTE    RES            :    3;
        BYTE    Unused;
    }BITS;

    WORD    VALUE;

}_DMA_STROBE;


typedef union 
{
    struct DMA_INT_BITS
    {
        BYTE    RES                                :    1;
        BYTE    CMD_INTRQ_OK                       :    1;
        BYTE    TASKFILE_READ_COMPLETE            :    1;
        BYTE    BSY_DRQ_POLL_DONE               :   1;
        BYTE    START_READ_1F0_RD_FIFO    :    1;
        BYTE    RD_1F0_FIFO_EMPTY               :    1;
        BYTE    WR_1F0_FIFO_FULL               :    1;
        BYTE    WR_1F0_FIFO_EMPTY               :    1;

        BYTE    DMA_XFER_OK                     :    1;
        BYTE    INTRQ_SEEN                           :    1;
        BYTE INT_EOT                                 :      1;
        BYTE EXT_EOT                                 :      1;
        BYTE    RES1                                  :    3;
        BYTE TEST3                                :     1;

    }BITS;

    WORD    VALUE;

}_DMA_INT;

typedef union 
{
    struct DMA_INT_ENABLE_BITS
    {

        BYTE    RES                                    :    1;
        BYTE    IE_CMD_INTRQ_OK                       :    1;
        BYTE    IE_TASKFILE_READ_COMPLETE    :    1;
        BYTE    IE_BSY_DRQ_POLL_DONE               :    1;
        BYTE    IE_START_READ_1F0_RD_FIFO    :    1;
        BYTE    IE_RD_1F0_FIFO_EMPTY               :    1;
        BYTE    IE_WR_1F0_FIFO_FULL               :    1;
        BYTE    IE_WR_1F0_FIFO_EMPTY               :    1;

        BYTE    IE_DMA_XFER_OK                     :    1;
        BYTE    IE_INTRQ_SEEN                           :    1;
        BYTE IE_INT_EOT                                 :      1;
        BYTE IE_EXT_EOT                                :      1;
        BYTE    RES1                                      :    3;
        BYTE TEST4                                    :     1;

    }BITS;

    
    WORD    VALUE;

}_DMA_INT_ENABLE;


typedef union 
{
    struct INTERRUPT_STATUS_BITS
    {
        BYTE    RESET               :     1;
        BYTE    SOF            :    1;
        BYTE    PSOF               :    1;
        BYTE    SUSP            :    1;
        BYTE    RESUME        :    1;
        BYTE    HS_STAT        :    1;
        BYTE    DMA            :    1;
        BYTE    VBUS            :    1;

        BYTE    EP0SETUP    :    1;
        BYTE    RESERVED2    :     1;
        BYTE    EP0RX               :    1;
        BYTE    EP0TX               :    1;
        BYTE    EP1RX               :    1;
        BYTE    EP1TX               :    1;    
        BYTE    EP2RX               :    1;
        BYTE    EP2TX               :    1;    

        BYTE    EP3RX               :    1;
        BYTE    EP3TX               :    1;
        BYTE    EP4RX               :    1;
        BYTE    EP4TX               :    1;    
        BYTE    EP5RX               :    1;
        BYTE    EP5TX               :    1;    
        BYTE    EP6RX               :    1;
        BYTE    EP6TX               :    1;    

        BYTE    EP7RX               :    1;
        BYTE    EP7TX               :    1;
        BYTE    RESERVED1    :    6;

    }BITS;

    struct
    {
        WORD LSW;
        WORD MSW;
    };

    DWORD    VALUE;

}_INTERRUPT_STATUS;


typedef union 
{
    struct FRAME_NO_BITS
    {

        BYTE    SOFL           :    8;
        BYTE    SOFH           :    3;
        BYTE    USOF           :    3;
        BYTE    RESERVED       :    2;

    }BITS;

    WORD    VALUE;

}_FRAME_NO;


typedef union 
{
    struct TESTMODE_BITS
    {

        BYTE    SE0_NAK       :1;
        BYTE    JSTATE       :1;
        BYTE    KSTATE       :1;
        BYTE    PRBS       :1;
        BYTE    FORCEFS       :1;
        BYTE    LPBK       :1;
        BYTE    PHYTEST       :1;
        BYTE    FORCEHS       :1;
        BYTE    Unused;

    }BITS;

    WORD    VALUE;

}_TESTMODE;

typedef union WORD_REG 
{
  struct 
  {
    BYTE LSB;
    BYTE MSB;
  };
  WORD VALUE;
} WORD_REG;

typedef struct D14_CNTRL_REG
{

    _ADDRESS_REG               D14_ADDRESS;
    
    WORD                       DUMMY_02;    

    _ENDPT_MAXSIZE             D14_ENDPT_MAXPKTSIZE;

    WORD                       DUMMY_06;    

    _ENDPT_TYPE                D14_ENDPT_TYPE;

    WORD                       DUMMY_0A;    

    _USB_MODE                  D14_MODE;

    WORD                       DUMMY_0E;    

    _INT_CONFIG                D14_INT_CONFIG;    
    _OTG_MODE                  D14_OTG_MODE;
    _INT_ENABLE                D14_INT_ENABLE;

    _INTERRUPT_STATUS          D14_INT;

  
    WORD                       D14_BUFFER_LENGTH;

    WORD                       D14_BUFFER_STATUS;    

    WORD_REG                   D14_DATA_PORT;

    WORD                       DUMMY_22;    

    WORD                       DUMMY_24;    

    WORD                       DUMMY_26;    

    _CONTROL                   D14_CONTROL_FUNCTION;
   
    WORD                       DUMMY_2A;    

    WORD                       D14_ENDPT_INDEX;
    
    WORD                       DUMMY_2E;    

    WORD                       D14_DMA_COMMAND;
    
    WORD                       DUMMY_32;    

    DWORD                      D14_DMA_TRANSFER_COUNTER;    

    _DMA_CONFIG                D14_DMA_CONFIG;

    WORD                       DUMMY_3A;    

    _DMA_HARDWARE              D14_DMA_HARDWARE;
    
    WORD                       DUMMY_3E;    

    DWORD                      D14_DATA_TASKFILE;

    WORD                       D14_CMD_STATUS_TASKFILE;
    
    WORD                       DUMMY_46;    

    WORD                       D14_ERROR_FEATURE_TASKFILE;    
    WORD                       D14_SECTOR_NUMBER;    
    WORD                       D14_BYTECOUNT_TASKFILE;    
    WORD                       D14_ALT_STATUS_DEVCNTRL_TASKFILE;    

    _DMA_INT                   D14_DMA_INT;

    WORD                       DUMMY_52;    

    _DMA_INT_ENABLE            D14_DMA_INT_ENABLE;

    WORD                       DUMMY_56;    

    WORD                       D14_DMA_ENDPOINT;
    
    WORD                       DUMMY_5A;    

    WORD                       DUMMY_5C;
    
    WORD                       DUMMY_5E;    

    _DMA_STROBE                DMA_STROBE_TIMING;
    
    WORD                       DUMMY_62;    

    WORD                       D14_DMA_BURST_COUNTER;

    WORD                       DUMMY_66;    

    WORD                       DUMMY_68;    
    WORD                       DUMMY_6A;    

    WORD                       DUMMY_6C;    
    WORD                       DUMMY_6E;    

    DWORD                      D14_CHIP_ID;    

    _FRAME_NO                  D14_FRAME_NUMBER;

    WORD                       DUMMY_76;    

    WORD                       D14_SCRATCH_REGISTER;

    WORD                       DUMMY_7A;    

    WORD                       D14_UNLOCK_DEVICE;    

    WORD                       DUMMY_7E;    

    WORD                       DUMMY_80;
    
    WORD                       DUMMY_82;    

    _TESTMODE                  D14_TEST_MODE;
}D14_CNTRL_REG;


#endif

