#ifndef DESCRIPTOR_H_
#define DESCRIPTOR_H_

#define DESC_MODULE_NAME_SIZE          (16)

#define W2B(w) ((BYTE)((w)>>0)),((BYTE)((w)>>8))
#define UNI_LAT(ch) ((BYTE)ch-0x00),(0x00)
#define UNI_CYR(ch) ((BYTE)ch-0xB0),(0x04)
//
#define ENDPT_NUMBER 4
#define INTERFACE_NO 1
#define CONFIG_LENGTH DESCRIPTOR_CONFIGURATION_SIZE+\
                      INTERFACE_NO*DESCRIPTOR_INTERFACE_SIZE+\
                      ENDPT_NUMBER*DESCRIPTOR_ENDPOINT_SIZE
// descriptor type
#define DESCRIPTOR_DEVICE                           1
#define DESCRIPTOR_CONFIGURATION                    2
#define DESCRIPTOR_STRING                           3
#define DESCRIPTOR_INTERFACE                        4
#define DESCRIPTOR_ENDPOINT                         5
#define DESCRIPTOR_DEVICE_QUALIFIER                 6
#define DESCRIPTOR_OTHER_SPEED_CONFIGURATION        7
#define DESCRIPTOR_INTERFACEPOWER                   8
//
#define DESCRIPTOR_DEVICE_SIZE                     18
#define DESCRIPTOR_CONFIGURATION_SIZE               9
#define DESCRIPTOR_INTERFACE_SIZE                   9
#define DESCRIPTOR_ENDPOINT_SIZE                    7
#define DESCRIPTOR_DEVICE_QUALIFIER_SIZE           10
#define DESCRIPTOR_OTHER_SPEED_CONFIGURATION_SIZE   9
//
#define FS_BULK_MAX_PACK_SZ         0x0040
#define FS_BULK_MAX_PACK_SZ_MASK    0x003F
#define HS_BULK_MAX_PACK_SZ         0x0200
#define HS_BULK_MAX_PACK_SZ_MASK    0x01FF

extern BYTE HS_DESCRIPTOR[];
extern BYTE FS_DESCRIPTOR[];
extern BYTE  *STRINGS[4][6];
extern BYTE OTHER_DESCRIPTOR[];

#endif /*#ifndef DESCRIPTOR_H_*/
