#include "hardware.h"


/*================================================================================================*/
#ifdef DEBUG_ERR_CNTR
  #define ErrorArraySize (128)
#endif
/*================================================================================================*/

/*================================================================================================*/
#ifdef DEBUG_ERR_CNTR
WORD ErrorArray[ ErrorArraySize ];
WORD ErrorCounter = 0;
#endif
int GlobalStop;
t_SPI_SettingsStore SPI_SettingsStore[ SPI_Store_Size ];
WORD SPI_SettingsStorePointer = 0;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
#ifdef DEBUG_ERR_CNTR
void AddErrorCounter
    (
    WORD Error
    )
    {
    ErrorArray[ ErrorCounter ] = Error;
    if (++ErrorCounter >= ErrorArraySize)
        ErrorCounter = ErrorArraySize;
    }
#endif
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void Sleep
    (
    int ValueMs
    )
    {
    /*
     *  2 -  Sleep
     */

    if (ValueMs <= 0)
        return;
        
    ConfiGureTimerPeriodAndWidth( TIMER2, (CurSystClkHz/1000) * ValueMs, 0 );
    ClearOverflowStatus( TIMER2 );
    EnableTimers( TIMER2 );
    while (!GetOverflowStatus( TIMER2 ))
        {
        continue;
        }
    DisableTimersImmediately( TIMER2 );
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void SleepMks
    (
    int ValueMks
    )
    {
    if (ValueMks <= 0)
        return;    
        
    ConfiGureTimerPeriodAndWidth( TIMER2, (CurSystClkHz/1000000) * ValueMks, 0 );
    ClearOverflowStatus( TIMER2 );
    *pTIMER2_COUNTER = 0;
    EnableTimers( TIMER2 );
    while (!GetOverflowStatus( TIMER2 ))
        {
        continue;
        }
    DisableTimersImmediately( TIMER2 );
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void DumpSPISettingsStore
    (
    WORD DeviceCode
    )
    {	
    /*
     *    SPI
     */
    int InterruptLatch = disable_interrupt;
    
    /*     ,    */
    UnDumpSPISettingsStore( DeviceCode );

    SPI_SettingsStore[ SPI_SettingsStorePointer ].DeviceCode = DeviceCode;
    SPI_SettingsStore[ SPI_SettingsStorePointer ].PF_Pins = PF_PINS_DATA & SPI_PF_PINS_MASK;
    DumpSPISettings( &SPI_SettingsStore[ SPI_SettingsStorePointer ].SPI_CONTROL_SET );

    SPI_SettingsStorePointer++;
    enable_interrupt( InterruptLatch );
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void UnDumpSPISettingsStore
    (
    WORD DeviceCode
    )
    {
    /*
     *    SPI
     */
    WORD i;
    int InterruptLatch = disable_interrupt;

    for (i = 0; (i < SPI_SettingsStorePointer); i++)
        {
        if (SPI_SettingsStore[ i ].DeviceCode == DeviceCode)
            {
            WORD j;
            /*   */
            PF_PINS_CLR( ~SPI_SettingsStore[ i ].PF_Pins & SPI_PF_PINS_MASK );
            PF_PINS_SET( SPI_SettingsStore[ i ].PF_Pins );
            UnDumpSPISettings( &SPI_SettingsStore[ i ].SPI_CONTROL_SET );

            for	(j = i; (j < SPI_SettingsStorePointer - 1); j++)
                {
                SPI_SettingsStore[ j ] = SPI_SettingsStore[ j+1 ];
                }
            SPI_SettingsStorePointer--;
            }
        }

    enable_interrupt( InterruptLatch );
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
