#ifndef HARDWARE_H_
#define HARDWARE_H_


#include "string.h"
#include "../../../include/extint.h"
#include "HAL_BF53X\HAL.h" 
#include "interruptHard.h"
#include "Ether.h"
#include "USB\USB.h"
#include "ATFlash.h"
#include "Altera.h"
#include "AlteraDataInterface.h"
#include "Initialize.h"
#include "ltr030.h"


/*================================================================================================*/
typedef struct
    {
    t_SPI_CONTROL_SET SPI_CONTROL_SET;
    WORD PF_Pins;    
    WORD DeviceCode;
    } t_SPI_SettingsStore;

#define SPI_PF_PINS_MASK (PF4 | PF5 | PF6 | PF10)
#define SPI_Store_Size 4

#define SPI_DEVICE_ALTERA_BURN 1
#define SPI_DEVICE_ALTERA_USER 2
#define SPI_DEVICE_THERMO      3
#define SPI_DEVICE_BOOT_FLASH  4
#define SPI_DEVICE_SDCARD      5

#define LTR030_ERROR_LOAD_ALTERA_BROACHING 1
#define LTR030_ERROR_BURN_ALTERA_BROACHING 2
#define LTR030_ERROR_USB_DATA_READ_DURING_DMA 3

#ifdef DEBUG_ERR_CNTR
extern WORD ErrorArray[];
extern WORD ErrorCounter;
void AddErrorCounter(WORD Error);
#else
#define ErrorArray NULL
#define ErrorCounter
#define AddErrorCounter(x)
#endif
/*================================================================================================*/

/*================================================================================================*/
extern unsigned eBufferLength;
extern unsigned char g_board_version;
extern int g_power_on;
extern int g_ring_mode;
extern int GlobalStop;
/*================================================================================================*/

/*================================================================================================*/
void DumpSPISettingsStore(WORD DeviceCode);
WORD ReadAlteraRegisters(volatile WORD *RegPointer);
void Sleep(int ValueMs);
void SleepMks(int ValueMks);
void SystemInitMy(void);
void UnDumpSPISettingsStore(WORD DeviceCode);
void WriteAlteraRegisters(volatile WORD *RegPointer, WORD Data);
/*================================================================================================*/
#endif /*#ifndef HARDWARE_H_*/
