#include "hardware.h"
#include "GlobDefs.h"


/*================================================================================================*/
/*    PPI */
const DWORD CrateSygnalBufferOverflow[ 2 ] = {0xFFFFFFFF, 0xFFFFAA02};
const DWORD CrateSygnalDataNewModule[ 2 ] = {0xFFFFFFFF, 0xFFFFAA01};
const DWORD CrateSygnalDMABufferOverflow[ 2 ] = {0xFFFFFFFF, 0xFFFFAA03};
BYTE DataRecvFromPCRunning = 0;
BYTE DataSendToPCRunning = 0;
WORD NumTestSpeedData = 0;
int TestClientSocket = INVALID_SOCKET;
BYTE TestSpeedReadRunning = 0;
BYTE TestSpeedWriteRunning = 0;

segment ("sdram0_bank1") t_FULL_DEVICE_DESCR_STATUS Descr =
    {
    ((1 << 24) | (0 << 16) | (0 << 8) | (1 << 0)),
    "1111111111\x0",
        {
#if defined(LTR030_ENDPOINT)
        "LTR030",
#elif defined(LTR031_ENDPOINT)
        "LTR031",
#else
  #error Compile endpoint not specified
#endif
        "XXXXXXXXXXXXXX\x0",
#if defined (__ADSPBF533__)
        "ADSP-BF533\x0",
#elif defined (__ADSPBF534__)
        "ADSP-BF534\x0",
#elif defined (__ADSPBF536__)
        "ADSP-BF536\x0",
#elif defined (__ADSPBF537__)
        "ADSP-BF537BBCZ\x0",
#endif
        1,
        (20 * 1000000),
        "Broaching Creation Date "__DATE__
        },
        {
#if defined (__ADSPBF533__)
        "ADSP-BF533\x0",
#elif defined (__ADSPBF534__)
        "ADSP-BF534\x0",
#elif defined (__ADSPBF536__)
        "ADSP-BF536\x0",
#elif defined (__ADSPBF537__)
        "ADSP-BF537BBCZ\x0",
#endif
        0,
        0,
        32,
        0,
        0,
        "22222222\x0"
        }        
    };

t_ltr030_Conf ltr030Conf=
    {   	
        {
        },
        {
        },
        {
        },
        {
        },
    INVALID_SOCKET,
    false
    };
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void GetSystemRegistersToStatusStruct
    (
    void
    )
    {
    portDISABLE_INTERRUPTS();
    ltr030Conf.LTR010_Emulation.Module_Presence_Low = AlteraReadCommand( ALTERA_MODULE_PRES_LO );
    ltr030Conf.LTR010_Emulation.Module_Presence_High = AlteraReadCommand( ALTERA_MODULE_PRES_HI );
    portENABLE_INTERRUPTS();
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void GetSystemStatusToStatusStruct
    (
    void
    )
    {
	Descr.Status.CurrCPUFreq = CurCoreClkHz;
	Descr.Status.CurrSystemFreq = CurSystClkHz;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void SetSystemRegistersFromStatusStruct
    (
    void
    )
    {
    portDISABLE_INTERRUPTS();
    AlteraWriteCommand( ALTERA_MODULE_SPEED_LO, ltr030Conf.LTR010_Emulation.SpeedSerial_Low );
    AlteraWriteCommand( ALTERA_MODULE_SPEED_HI, ltr030Conf.LTR010_Emulation.SpeedSerial_High );
    portENABLE_INTERRUPTS();
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
