#ifndef DATAHOOK_H_
#define DATAHOOK_H_

#include "include/extint.h"

/*================================================================================================*/
#define N_CRATE_MODULES (16)
#define MAX_DATA_SIZE (16384)
/*================================================================================================*/

/*================================================================================================*/
enum e_Module
    {
    e_Module_None = 0,
    e_Module_LTR11,
    e_Module_LTR22,
    e_Module_LTR27,
    e_Module_LTR34,
    e_Module_LTR41,
    e_Module_LTR42,
    e_Module_LTR43,
    e_Module_LTR51,
    e_Module_LTR212
    };

struct datahook_cfg
    {
    /*   */
    enum e_Module module;
    /*       */
    int data_size;
    /*   
     * 
     *   1 -  ,    
     *   2 -     
     *   3 -   ,   
     */
    void (*cb_hook)(enum e_Module, int, const t_uint16 *);
    };
/*================================================================================================*/

/*================================================================================================*/
void datahook(unsigned long n_data);
void put_host_data(const t_uint16 *data, int data_size);
void put_module_data(int module_num, const t_uint16 *data, int data_size);
/*================================================================================================*/

#endif /*#ifndef DATAHOOK_H_*/
