#include <cdefBF537.h>
#include <ccblkfn.h>

#include "GlobDefs.h"
#include "ifuart.h"


/*================================================================================================*/
#define UART_BUFSZ (10)
/*================================================================================================*/

/*================================================================================================*/
static unsigned char f_uart_rxbuf[ UART_BUFSZ ];
static unsigned char f_uart_txbuf[ UART_BUFSZ ];
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
int get_uart
    (
    unsigned char *data
    )
    {
    int n;
    n = 0;
    while (!(*pUART1_LSR & DR))
        {
        if (++n >= 20)
            break;
        }
    if (n >= 20)
        return 0;
        
    *data = *pUART1_RBR;
    return 1;    
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void put_uart
    (
    unsigned char data
    )
    {
    while (!(*pUART0_LSR & THRE))
        {
        continue;
        }
    *pUART0_THR = data;
    while (!(*pUART0_LSR & TEMT))
        {
        continue;
        }
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
int test_uart
    (
    void
    )
    {
    int i;
    
    *pPORTGIO_INEN &= ~(1 << 13);
    *pPORTGIO_DIR |= 1 << 13;
    
    portDISABLE_INTERRUPTS();
    AlteraWriteCommand( 0x09, 0x01 );
    AlteraWriteCommand( 0x0A, 0x02 );
    AlteraWriteCommand( 0x0B, 0x03 );
    AlteraWriteCommand( 0x0C, 0x00 );
    AlteraWriteCommand( 0x0E, 0x00 );
    AlteraWriteCommand( 0x0F, 0x00 );
    portENABLE_INTERRUPTS();
    
    *pPORTGIO_SET = 1 << 13;
    
    for (i = 0; (i < UART_BUFSZ); i++)
        {
        f_uart_txbuf[ i ] = i;
        put_uart( f_uart_txbuf[ i ] );
        if (!get_uart( &f_uart_rxbuf[ i ] ))
            return 1;
        if (f_uart_rxbuf[ i ] != f_uart_txbuf[ i ])
            return 2;
        }
        
    *pPORTGIO_CLEAR = 1 << 13;
    put_uart( 0x22 );
    if (get_uart( f_uart_txbuf ))
        return 3;
    
    return 0;
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void uart_deinit
    (
    void
    )
    {
    *pPORTFIO_DIR &= ~0x01;
    *pPORTF_FER &= ~0x09;
    *pPORTGIO_INEN |= 1 << 13;
    *pPORTGIO_DIR &= ~(1 << 13);
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
void uart_init
	(
	void
	)
	{
	*pPORTFIO_DIR |= 0x01;
	*pPORTFIO_DIR &= ~0x08;
	
	*pPORTF_FER |= 0x09;
	*pPORT_MUX &= ~PFDE;
	ssync();
	
	*pUART0_LCR = 0x80;
	ssync();
	*pUART0_DLL = 434 & 0xFF;
	*pUART0_DLH = (434 >> 8) & 0xFF;
	ssync();
	*pUART0_LCR = 0x03;
	*pUART0_GCTL = UCEN;
	ssync();
	
	*pUART1_LCR = 0x80;
	ssync();
	*pUART1_DLL = 434 & 0xFF;
	*pUART1_DLH = (434 >> 8) & 0xFF;
	ssync();
	*pUART1_LCR = 0x03;
	*pUART1_GCTL = UCEN;
	ssync();
	}
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
