/*
 *       .
 */
 
 
#include "rtc.h"
 
 
/*===============================================================================================*/
static const unsigned char f_ct_rtc_busaddr = 0x68;
/*===============================================================================================*/
 
/*===============================================================================================*/
/*-----------------------------------------------------------------------------------------------*/
void get_rtc
    (
    struct rtc_tm *t,                       /* () -   */
    enum RTCErr *err                        /* () -   */
    )
    {
    /*
     *    .
     * 
     *            -   .
     */
    enum I2CErr i2c_err;
    unsigned char put_data[ 1 ] = {0x01};
    unsigned char rtc_t[ 7 ];
    transmitreceive_i2c( f_ct_rtc_busaddr, 1, put_data, 7, rtc_t, &i2c_err );
    
    if (i2c_err == I2CErr_Ok)
        {
        t->sec = (rtc_t[ 0 ] & 0x0F) + ((rtc_t[ 0 ] >> 4) & 0x07) * 10;
        t->min = (rtc_t[ 1 ] & 0x0F) + ((rtc_t[ 1 ] >> 4) & 0x07) * 10;
        t->hour = (rtc_t[ 2 ] & 0x0F) + ((rtc_t[ 2 ] >> 4) & 0x03) * 10;
        t->day = (rtc_t[ 4 ] & 0x0F) + ((rtc_t[ 4 ] >> 4) & 0x03) * 10;
        t->mon = (rtc_t[ 5 ] & 0x0F) + ((rtc_t[ 5 ] >> 4) & 0x01) * 10;
        t->year = (rtc_t[ 6 ] & 0x0F) + ((rtc_t[ 6 ] >> 4) & 0x0F) * 10;
        }
    else
        {
        *err = RTCErr_i2c;
        }
    }
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
void init_rtc
    (
    void
    )
    {
    /*
     *    .
     * 
     *      I2C.
     */
    enum I2CErr i2c_err;
    unsigned char put_data[ 2 ] = {0x0C, 0x00};
    init_i2c();     
    transmit_i2c( f_ct_rtc_busaddr, 2, put_data, &i2c_err );
    } 
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
void set_rtc
    (
    const struct rtc_tm *t,                 /* () -   */
    enum RTCErr *err                        /* () -   */
    )
    {
    /*
     *     .
     * 
     *       -       .
     */
    enum I2CErr i2c_err;
    unsigned char put_data[ 20 ];
    
    *err = RTCErr_Ok;
    
    /*put_data[ 0 ] = 2;
    int i;
    for (i = 1; i < 21; i++)
        put_data[ i ] = 0xFF;*/
    
    put_data[ 0 ] = 0x00;
    put_data[ 1 ] = 0x00;
    put_data[ 2 ] = (t->sec % 10) | ((t->sec / 10) << 4);
    put_data[ 3 ] = (t->min % 10) | ((t->min / 10) << 4);
    put_data[ 4 ] = (t->hour % 10) | ((t->hour / 10) << 4);
    put_data[ 5 ] = 1;
    put_data[ 6 ] = (t->day % 10) | ((t->day / 10) << 4);
    put_data[ 7 ] = (t->mon % 10) | ((t->mon / 10) << 4);
    put_data[ 8 ] = (t->year % 10) | ((t->year / 10) << 4);
    
    int i;
    for (i = 9; i < 20; i++)
        {
        put_data[ i ] = 0x00;
        }
    
    
    transmit_i2c( f_ct_rtc_busaddr, 20, put_data, &i2c_err );
    if (i2c_err != I2CErr_Ok)
        {
        *err = RTCErr_i2c;
        }
    }
/*-----------------------------------------------------------------------------------------------*/
/*===============================================================================================*/ 
