#include "GlobDefs.h"


/*================================================================================================*/
DMA_DESCRIPTOR_UNION BufferRead;
DMA_DESCRIPTOR_UNION BufferWrite;
DMA_DESCRIPTOR_UNION Test1_Dest_Descr;
DMA_DESCRIPTOR_UNION Test1_Source_Descr;
DMA_DESCRIPTOR_UNION Test2_Dest_Descr;
DMA_DESCRIPTOR_UNION Test2_Source_Descr;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void TestAlteraInterface
	(
	void
	)
	{
	DWORD Address = 0;
	DWORD Address1 = 0;   
	WORD i;
	DWORD Value = 0;
	
	for (i = 0; (i < 1024); i++)
		{
		((DWORD*)SPORT_Tran_Data)[ i ] = 0x8080 | (i << 16);
		}

	AlteraWriteCommand( ALTERA_MODULE_SPEED_LO, 0xFF );
	AlteraWriteCommand( ALTERA_MODULE_SPEED_HI, 0xFF );
	while (1)
		{
		StartWriteSPORT_DMA( SPORT_Tran_Data, 1024 );
		while (!AlteraSPORTReady())
			{
			continue;
			}
		DelayMks( 5000 );
		for (i = 0; (i < 512); i++)
			{
			if ((((DWORD*)PPI_Recv_Data)[ Address ] >> 16) != i)
				{
				Value--;
				i = 30000;
				}
			Address1++;    	    
			if (++Address >= (PPI_Recv_Data_Size_Word >> 1))
				Address = 0;
			}
		}
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
bool TESTDMAAvailable
	(
	void
	)
	{
	if ((*pMDMA_S1_IRQ_STATUS & DMA_RUN) || (*pMDMA_D1_IRQ_STATUS & DMA_RUN))
		return false;
	return true;    
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
bool TestSDRAM
	(
	void
	)
	{
	int i;  

	for (i = 0; (i < 1024 * 1024 * 16); i++)
		{
		SDRAM_ADDRESS[ i ] = i;
		}

	for (i = 0; (i < 1024 * 1024 * 16); i++)
		{
		if (SDRAM_ADDRESS[ i ] != (WORD)i)
			{
			return false;
			}
		}
	return true;
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
DWORD TestSDRAMReadSpeed
	(
	void
	)
	{
	int i;
	DWORD TimerValue;

	ConfiGureTimerPeriodAndWidth( TIMER2, 0xFFFFFFFF, 0 );
	EnableTimers( TIMER2 );

	for (i = 0; (i < 1024 * 1024 * 8); i++)
		{
		if (((DWORD *)SDRAM_ADDRESS)[ i ] != i)
			{
			DisableTimersImmediately( TIMER2 );
			return 0;
			}
		}

	TimerValue = *pTIMER2_COUNTER;
	DisableTimersImmediately( TIMER2 );

	return TimerValue;
	}
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
DWORD TestSDRAMWriteSpeed
	(
	void
	)
	{
	int i;
	DWORD TimerValue;

	ConfiGureTimerPeriodAndWidth( TIMER2, 0xFFFFFFFF, 0 );
	EnableTimers( TIMER2 );

	for (i = 0;(i < 1024 * 1024 * 8); i++)
		{
		((DWORD *)SDRAM_ADDRESS)[ i ] = i;
		}   

	TimerValue = *pTIMER2_COUNTER;
	DisableTimersImmediately( TIMER2 );

	return TimerValue;
	}
/*------------------------------------------------------------------------------------------------*/


#if 0
/*
DWORD TestSDRAMWriteSpeedDMA(void)
{
    int i=0;
    WORD j;      
    WORD * SPORTArrayPointer=Sport_BufferArray_MemDSP;
    
    ConfiGureTimerPeriodAndWidth(TIMER2, 0xffffffff,0);					          		          	         					   
       
    BufferWrite.Large.pNext=(void *)&BufferWrite;
    BufferWrite.Large.StartAddress=SDRAM_ADDRESS;
    BufferWrite.Large.Config.VALUE=PrepareDMAConfig(true, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, true);
    BufferWrite.Large.XCount=TestDMASize;
    BufferWrite.Large.XModify=2;     
    
    BufferRead.Large.pNext=(void *)&BufferRead;
    BufferRead.Large.StartAddress=Sport_BufferArray_MemDSP;
    BufferRead.Large.Config.VALUE=PrepareDMAConfig(false, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, true);
    BufferRead.Large.XCount=TestDMASize;
    BufferRead.Large.XModify=2;            
    
    for (j=0;j<(WORD)TestDMASize;j++) 
    {
        *SPORTArrayPointer++=i++;
    }
        
    //        destination
    
    ConfigureDMAChannelDesc(DMA_MDMA_S1, &BufferRead);
	ConfigureDMAChannelDesc(DMA_MDMA_D1, &BufferWrite); 
	    
    EnableTimers(TIMER2);           	    	
	
    PrepareDescrDMAAndStart(DMA_MDMA_S1,  DMA_DESCR_7, DMA_FLOW_LARGE);
	PrepareDescrDMAAndStart(DMA_MDMA_D1,  DMA_DESCR_7, DMA_FLOW_LARGE); 
	    
    while (i<(1024*1024*16))
    {        
        for (j=0;j<(WORD)TestDMASize;j++) 
    	{
        	*SPORTArrayPointer++=i++;        
    	} 
        
        while (!TESTDMAAvailable());  
        
        if (SPORTArrayPointer>=&Sport_BufferArray_MemDSP[TestDMASize*2])     
        {
            SPORTArrayPointer=Sport_BufferArray_MemDSP;
            BufferRead.Large.StartAddress=&Sport_BufferArray_MemDSP[TestDMASize];               	        
        }        
        else
        {
            BufferRead.Large.StartAddress=Sport_BufferArray_MemDSP;               	        
        }
        
        BufferWrite.Large.StartAddress=(WORD *)((DWORD) BufferWrite.Large.StartAddress+(TestDMASize*2));  
		PrepareDescrDMAAndStart(DMA_MDMA_S1,  DMA_DESCR_7, DMA_FLOW_LARGE);
		PrepareDescrDMAAndStart(DMA_MDMA_D1,  DMA_DESCR_7, DMA_FLOW_LARGE); 					   			                
    }
    
    while (!TESTDMAAvailable());       
      
    DWORD TimerValue=*pTIMER2_COUNTER;
    DisableTimersImmediately(TIMER2);	   
    
    return TimerValue; 
}

DWORD TestSDRAMReadSpeedDMA(void)
{
    register int i=0;    
    register WORD j;
      
    register WORD * SPORTArrayPointer=Sport_BufferArray_MemDSP;
    
    ConfiGureTimerPeriodAndWidth(TIMER2, 0xffffffff,0);					          		          	         					   
       
    BufferWrite.Large.pNext=(void *)&BufferWrite;
    BufferWrite.Large.StartAddress=Sport_BufferArray_MemDSP;
    BufferWrite.Large.Config.VALUE=PrepareDMAConfig(true, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, true);
    BufferWrite.Large.XCount=TestDMASize;
    BufferWrite.Large.XModify=2;      
    
    BufferRead.Large.pNext=(void *)&BufferRead;
    BufferRead.Large.StartAddress=SDRAM_ADDRESS;
    BufferRead.Large.Config.VALUE=PrepareDMAConfig(false, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, true);
    BufferRead.Large.XCount=TestDMASize;
    BufferRead.Large.XModify=2;   
    
    //        destination
	ConfigureDMAChannelDesc(DMA_MDMA_S1, &BufferRead);
	ConfigureDMAChannelDesc(DMA_MDMA_D1, &BufferWrite);    	 
    SPORTArrayPointer=&Sport_BufferArray_MemDSP[2*TestDMASize];
	
	
    EnableTimers(TIMER2);     
    	
    PrepareDescrDMAAndStart(DMA_MDMA_S1,  DMA_DESCR_7, DMA_FLOW_LARGE);
	PrepareDescrDMAAndStart(DMA_MDMA_D1,  DMA_DESCR_7, DMA_FLOW_LARGE); 
	    
    while (i<(1024*1024*16))
    {
        while (!TESTDMAAvailable());       
        
        if (SPORTArrayPointer>=&Sport_BufferArray_MemDSP[2*TestDMASize])
        {
            SPORTArrayPointer=Sport_BufferArray_MemDSP;
            BufferWrite.Large.StartAddress=&Sport_BufferArray_MemDSP[TestDMASize];
        }
        else
        {
            BufferWrite.Large.StartAddress=Sport_BufferArray_MemDSP;
        }        
        
        BufferRead.Large.StartAddress=(WORD *)((DWORD)BufferRead.Large.StartAddress+(TestDMASize*2));
        if ((DWORD)BufferRead.Large.StartAddress<(DWORD)(1024*1024*32))
        {
        	PrepareDescrDMAAndStart(DMA_MDMA_S1,  DMA_DESCR_7, DMA_FLOW_LARGE);
			PrepareDescrDMAAndStart(DMA_MDMA_D1,  DMA_DESCR_7, DMA_FLOW_LARGE); 					
        }
                
        for (j=0;j<(WORD)TestDMASize;j++) 
		{
			if (*SPORTArrayPointer++!=(WORD)i++) 
		    {
		    	DisableTimersImmediately(TIMER2);
	    		return 0;
		    }	        
		}       
    }   
        
    DWORD TimerValue=*pTIMER2_COUNTER;
    DisableTimersImmediately(TIMER2);	   
    
    return TimerValue; 
}

DWORD TestSDRAMSpeedDMAQuick(bool FromSDRAMWrite)
{
    ConfiGureTimerPeriodAndWidth(TIMER2, 0xffffffff,0);					          		          	         					   
       
    BufferWrite.Large.pNext=(void *)&BufferWrite;
    if (FromSDRAMWrite)
    {
        BufferWrite.Large.StartAddress=Sport_BufferArray_MemDSP;
    }
    else
    {
    	BufferWrite.Large.StartAddress=SDRAM_ADDRESS;
    }
    BufferWrite.Large.Config.VALUE=PrepareDMAConfig(true, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, true);
    BufferWrite.Large.XCount=SPORT_BUFFER_ARRAY_SIZE_MEM_DSP;
    BufferWrite.Large.XModify=2;      
    
    BufferRead.Large.pNext=(void *)&BufferRead;    
    if (FromSDRAMWrite)
    {
    	BufferRead.Large.StartAddress=SDRAM_ADDRESS;
    }
    else 
    {
        BufferRead.Large.StartAddress=Sport_BufferArray_MemDSP;
    }    
    BufferRead.Large.Config.VALUE=PrepareDMAConfig(false, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, true);
    BufferRead.Large.XCount=SPORT_BUFFER_ARRAY_SIZE_MEM_DSP;
    BufferRead.Large.XModify=2;   
    
    //        destination
	ConfigureDMAChannelDesc(DMA_MDMA_S1, &BufferRead);
	ConfigureDMAChannelDesc(DMA_MDMA_D1, &BufferWrite);    	 
	
    EnableTimers(TIMER2);     
    	
    PrepareDescrDMAAndStart(DMA_MDMA_S1,  DMA_DESCR_7, DMA_FLOW_LARGE);
	PrepareDescrDMAAndStart(DMA_MDMA_D1,  DMA_DESCR_7, DMA_FLOW_LARGE);    
    
    while (!TESTDMAAvailable());             
    
    DWORD TimerValue=*pTIMER2_COUNTER;
    DisableTimersImmediately(TIMER2);	   
    
    return TimerValue;
}

void PrepareTestStructDMA(void)
{    
    Test1_Source_Descr.Large.pNext=(void *)&Test2_Source_Descr;
	Test1_Source_Descr.Large.StartAddress=Sport_BufferArray_MemDSP;
	Test1_Source_Descr.Large.Config.VALUE=PrepareDMAConfig(false, DMA_WORD_16, false, DMA_DESCR_7, DMA_FLOW_LARGE, false);
	Test1_Source_Descr.Large.XCount=1024*16;
	Test1_Source_Descr.Large.XModify=2;	
	
	Test1_Dest_Descr.Large.pNext=(void *)&Test2_Dest_Descr;
	Test1_Dest_Descr.Large.StartAddress=&SDRAM_BANK3[1024*128];
	Test1_Dest_Descr.Large.Config.VALUE=PrepareDMAConfig(true, DMA_WORD_16, false, DMA_DESCR_7, DMA_FLOW_LARGE, false);
	Test1_Dest_Descr.Large.XCount=1024*16;
	Test1_Dest_Descr.Large.XModify=2;	
	
	Test2_Source_Descr.Large.pNext=(void *)&Test1_Source_Descr;
	Test2_Source_Descr.Large.StartAddress=&SDRAM_BANK3[1024*128];
	Test2_Source_Descr.Large.Config.VALUE=PrepareDMAConfig(false, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, false);
	Test2_Source_Descr.Large.XCount=1024*16;
	Test2_Source_Descr.Large.XModify=2;	
	
	Test2_Dest_Descr.Large.pNext=(void *)&Test1_Dest_Descr;
	Test2_Dest_Descr.Large.StartAddress=(void *)pBANK2_DATA;
	Test2_Dest_Descr.Large.Config.VALUE=PrepareDMAConfig(true, DMA_WORD_16, false, DMA_DESCR_0, DMA_FLOW_STOP, false);
	Test2_Dest_Descr.Large.XCount=1024*16;
	Test2_Dest_Descr.Large.XModify=0;	
}
   
*/
#endif
/*================================================================================================*/
